using Test
using BloqadeExpr, YaoBlocks, YaoAPI, BitBasis
using SparseArrays
using LinearAlgebra


@testset "getindex" begin
    pb = rydberg_h([(5*randn(), 5*randn()) for i=1:5]; Ω=0.3, Δ=0.5)
    mpb = mat(pb)
    allpass = true
    for i=basis(pb), j=basis(pb)
        allpass &= pb[i, j] ≈ mpb[Int(i)+1, Int(j)+1]
    end
    @test allpass

    allpass = true
    for j=basis(pb)
        allpass &= vec(pb[:, j]) ≈ mpb[:, Int(j)+1]
        allpass &= vec(pb[j,:]) ≈ mpb[Int(j)+1,:]
        allpass &= vec(pb[:, EntryTable([j], [1.0+0im])]) ≈ mpb[:, Int(j)+1]
        allpass &= vec(pb[EntryTable([j], [1.0+0im]),:]) ≈ mpb[Int(j)+1,:]
    end
    @test allpass
end

@testset "isreal" begin
    @test isreal(SumOfN(nsites=2))
    @test isreal(SumOfZ(nsites=2))

    scale = 2 * SumOfX(nsites=3)
    @test isreal(scale)
    scale = im * SumOfX(nsites=3)
    @test !isreal(scale)

    # 3-level
    atoms = [(rand(), rand()) for i=1:3]
    @test !isreal(rydberg_h(atoms; Ω = 1.0, ϕ = sin, Δ = 1.0))
    @test !isreal(rydberg_h(atoms; ϕ = sin, Δ = 1.0))
    @test isreal(rydberg_h(atoms; Ω = sin, Δ = 1.0))

    @test !isreal(rydberg_h_3(atoms; Ω_r = 1.0, ϕ_r = sin, Ω_hf = 1.0, ϕ_hf = sin))
    @test !isreal(rydberg_h_3(atoms; Ω_r = 1.0, Ω_hf = 1.0, ϕ_hf = sin))
    @test isreal(rydberg_h_3(atoms; Ω_r = 1.0, Ω_hf = sin))
end

@testset "Hamiltonian Term Default Values" begin
    pauli_zs_term = SumOfZ(2)
    @test pauli_zs_term.Δ == 1
    
    number_ops_term = SumOfN(2)
    @test number_ops_term.Δ == 1

    pauli_xs_term = SumOfX(2)
    @test pauli_xs_term.Ω == 1
end

@testset "Qudit Numbers" begin
    @test YaoAPI.nqudits(PdPhase(1.0)) == 1
    @test YaoAPI.nqudits(PuPhase(1.0)) == 1
    @test YaoAPI.nqudits(SumOfZ(10)) == 10

    # 3-level
    @test YaoAPI.nqudits(PdPhase_01(π)) == 1
    @test YaoAPI.nqudits(PdPhase_1r(0.0)) == 1
    @test YaoAPI.nqudits(PuPhase_01(π)) == 1
    @test YaoAPI.nqudits(PuPhase_1r(0.0)) == 1
    @test YaoAPI.nqudits(SumOfZ_01(10)) == 10
end

@testset "Equality Operator" begin
    @test SumOfZ(10, 1.0) == SumOfZ(10, 1.0)
    @test !(SumOfZ(1, 1.0) == SumOfZ(2, 1.0))
    @test !(SumOfZ(5, 0.5) == SumOfZ(5, 0.3))

    h = rydberg_h([(5*randn(), 5*randn()) for i=1:5]; Ω=0.3, Δ=0.5)
    @test h == copy(h)
    h3 = rydberg_h_3([(5*randn(), 5*randn()) for i=1:5]; Ω_r=0.3, Δ_r=0.5, Ω_hf=0.3, Δ_hf=0.5)
    @test h3 == copy(h3)
end

@testset "Hamiltonian Size" begin
    hamiltonian = BloqadeExpr.Hamiltonian(Float64, SumOfX(6, sin) + SumOfZ(6, cos))
    @test size(hamiltonian) == (64, 64)
    @test size(hamiltonian, 2) == 64

    #if REPL is 32bit or 64bit Int for sparse will have differet size:
    if sizeof(Int) == 8
        @test storage_size(hamiltonian) == 6672
    else
        @test storage_size(hamiltonian) == 4872
    end
    step_hamiltonian = hamiltonian(0.1)
    @test size(step_hamiltonian) == (64, 64)
    @test size(step_hamiltonian, 2) == 64
end

@testset "Hamiltonian/SumOfLinop type" begin
    hamiltonian = BloqadeExpr.Hamiltonian(Float64, SumOfX(6, sin) + SumOfZ(6, cos))
    @test precision_type(hamiltonian) == Float64
    @test highest_type(hamiltonian) == Float64
    
    step_hamiltonian = hamiltonian(0.1)
    @test precision_type(step_hamiltonian) == Float64
    @test highest_type(step_hamiltonian) == Float64
end

@testset "SumOfLinop Norm" begin 
    hamiltonian = BloqadeExpr.Hamiltonian(Float64, SumOfZ(1, sin))
    step_hamiltonian = hamiltonian(π/2)
    @test LinearAlgebra.opnorm(step_hamiltonian,1) == 1.0
end


@testset "SumOfLinop " begin


    Ham = BloqadeExpr.Hamiltonian(Float64, SumOfX(1, sin) + SumOfZ(1,cos))


    t = 0.645
    StepHam = Ham(0.645)


    @test ishermitian(StepHam) == true
    

    # check coefficents:
    for (i,f) in enumerate(Ham.fs)
        @test f(t) == StepHam.fvals[i]
    end
    @test StepHam.ts === Ham.ts


    #=
    # check basic algos :+
    AddOp = StepHam + StepHam
    @test AddOp.ts === StepHam.ts
    @test AddOp.ts === Ham.ts

    for (i,f) in enumerate(Ham.fs)
        @test AddOp.fvals[i] == f(t) + f(t)
    end

    @test LinearAlgebra.is_hermitian(AddOp) == true

    # check basic algos :-
    SubVHam = StepHam - StepHam
    @test SubVHam.ts === StepHam.ts
    @test SubVHam.ts === Ham.ts

    for (i,f) in enumerate(Ham.fs)
        @test SubVHam.fvals[i] == f(t) - f(t)
    end

    @test LinearAlgebra.is_hermitian(SubVHam) == true
    =#

    # check basic algos :*
    MulVHam = 0.5*StepHam 
    @test MulVHam.ts === StepHam.ts
    @test MulVHam.ts === Ham.ts

    for (i,f) in enumerate(Ham.fs)
        @test MulVHam.fvals[i] == 0.5*f(t)
    end

    @test ishermitian(MulVHam) == true
    @test isskewhermitian(MulVHam) == false


     # check basic algos :*
     MulVHam2 = 0.5im*StepHam 
     @test MulVHam2.ts === StepHam.ts
     @test MulVHam2.ts === Ham.ts
 
     for (i,f) in enumerate(Ham.fs)
         @test MulVHam2.fvals[i] == 0.5im*f(t)
     end   

     @test ishermitian(MulVHam2) == false
     @test isskewhermitian(MulVHam2) == true


     # check basic algos :*
     MulVHam3 = (2.3+0.1im)*StepHam 
     @test MulVHam3.ts === StepHam.ts
     @test MulVHam3.ts === Ham.ts
 
     for (i,f) in enumerate(Ham.fs)
         @test MulVHam3.fvals[i] == (2.3+0.1im)*f(t)
     end   

     @test ishermitian(MulVHam3) == false
     @test isskewhermitian(MulVHam3) == false



end


@testset "is_time_dependent" begin
    nsites = 3
    atoms = [(1, i) for i = 1:nsites]
    params = [nothing, 1.0, [0.1 for _ in 1:nsites], sin, [sin for _ in 1:nsites]]
    @testset "is_time_dependent (2-level)" begin
        @testset "Ω=$Ω, Δ=$Δ, ϕ=$ϕ" for Ω in params[2:end], Δ in params, ϕ in params
            h = rydberg_h(atoms; Ω, Δ, ϕ)
            @test !(BloqadeExpr.is_time_dependent(h)) == all(x->(BloqadeExpr.is_const_param(x) || isnothing(x)), [Ω, Δ, ϕ])
        end
    end;
    @testset "is_time_dependent (3-level)" begin
        @testset "Ω_hf=$Ω_hf, Δ_hf=$Δ_hf, ϕ_hf=$ϕ_hf" for Ω_hf in params[2:2], Δ_hf in params[3:4], ϕ_hf in params[5:5]
            @testset "Ω_r=$Ω_r, Δ_r=$Δ_r, ϕ_r=$ϕ_r" for Ω_r in params[2:end], Δ_r in params, ϕ_r in params
                h = rydberg_h_3(atoms; Ω_hf, Δ_hf, ϕ_hf, Ω_r, Δ_r, ϕ_r)
                @test !(BloqadeExpr.is_time_dependent(h)) == all(x->(BloqadeExpr.is_const_param(x) || isnothing(x)), [Ω_hf, Δ_hf, ϕ_hf, Ω_r, Δ_r, ϕ_r])
            end
        end
    end;
    @test !BloqadeExpr.is_time_dependent(nothing)
    @test !BloqadeExpr.is_time_function(SumOfN(nsites))
end

# convenient mapping functions for atoms

"""
    matrix_to_positions(locs::AbstractMatrix{T}) -> Vector{NTuple{D, T}}

Convert a dxn location matrix to a list of positions.
"""
function matrix_to_positions(locs::AbstractMatrix)
    return [(locs[:, i]...,) for i in 1:size(locs, 2)]
end

default_unit(unit, x) = x

default_unit(unit, x::Quantity) = uconvert(unit, x).val
default_unit(unit::typeof(NoUnits), x::Quantity) = uconvert(unit, x)
function default_unit(unit, xs::Tuple)
    return map(xs) do x
        return default_unit(unit, x)
    end
end

function default_unit(unit, range::AbstractRange)
    a = default_unit(unit, first(range))
    b = default_unit(unit, step(range))
    c = default_unit(unit, last(range))
    return a:b:c
end

function default_unit(unit, x::AbstractArray{S}) where {T,S<:Quantity{T}}
    y = similar(x, T)
    @inbounds for i in eachindex(x)
        y[i] = default_unit(unit, x[i])
    end
    return y
end

using Test
using BloqadeExpr

@testset "subspace" begin
    @test_throws ArgumentError space = Subspace(8, [1, 3, 5, 300])

    # 1, 3, 5, 10 are full space indexes
    # map[fullspace_index] = subspace index
    space = Subspace(8, [1, 3, 5, 10])
    @test space.map[3] == 2
    @test space.map[10] == 4

    for pair in space
        @test pair.first in keys(space)
        @test pair.second in values(space)
    end

    @test space[10] == 4

    @test space[bit"1010"] == 4

    @test keys(space) == Set([1, 3, 5, 10])

    @test sort(collect(values(space))) == [1, 2, 3, 4]

    @test haskey(space, 1)
    
    copied_space = copy(space)
    @test copied_space.nqubits == space.nqubits
    @test copied_space.map == space.map
    @test copied_space.subspace_v == space.subspace_v

    @test vec(space) == [1, 3, 5, 10]

    state = rand(15)
    @test state[space] == state[[2, 4, 6, 11]]
    
    # non-compact print
    show(stdout, MIME"text/plain"(), space)

    print("\n\n")

    # compact print
    space = Subspace(6, [i for i in 1:40])
    show(IOContext(stdout, :limit => true), MIME"text/plain"(), space)

    # all contents equal
    space1 = Subspace(6, [i for i in 1:40])
    space2 = Subspace(6, [i for i in 1:40])
    @test space1 == space2

    # nqubits mismatch
    space2 = Subspace(7, [i for i in 1:40])
    @test !(space1 == space2)

    # subspace values length mismatch
    space2 = Subspace(6, [i for i in 1:20])
    @test !(space1 == space2)

    # map mismatch
    space2 = Subspace(6, [i for i in 5:44])
    @test !(space1 == space2)

end

function emit_dynamic_terms(ex::Add)
    list = []
    for t in subblocks(ex)
        append!(list, emit_dynamic_terms(t))
    end
    return list
end

function emit_dynamic_terms(ex::Scale)
    return map(emit_dynamic_terms(content(ex))) do (f, t)
        return f => factor(ex) * t
    end
end

emit_dynamic_terms(ex::RydInteract) = Any[one=>ex,]

function emit_dynamic_terms(ex::SumOfXTypes)
    op = (ex isa SumOfX ? X : (ex isa SumOfX_01 ? X_01 : X_1r))
    return if ex.Ω isa Number || ex.Ω isa Vector{<:Number}
        Any[one=>ex,]
    elseif ex.Ω isa Vector && is_time_function(ex.Ω)
        Any[Ω => put(ex.nsites, i => op) for (i, Ω) in enumerate(ex.Ω)]
    elseif is_time_function(ex.Ω)
        Any[ex.Ω=>sum(put(ex.nsites, i => op) for i in 1:ex.nsites)]
    else
        error("unexpected type for Ω: $(typeof(ex.Ω))")
    end
end

function emit_dynamic_terms(ex::SumOfZAndNTypes)
    op = if ex isa SumOfZ
        Z
    elseif ex isa SumOfZ_01
        Z_01
    elseif ex isa SumOfZ_1r
        Z_1r
    elseif ex isa SumOfN
        ConstGate.P1
    elseif ex isa SumOfN_1
        N_1
    elseif ex isa SumOfN_r
        N_r
    end

    return if ex.Δ isa Number || ex.Δ isa Vector{<:Number}
        Any[one=>ex]
    elseif ex.Δ isa Vector && is_time_function(ex.Δ)
        Any[Δ => put(ex.nsites, i => op) for (i, Δ) in enumerate(ex.Δ)]
    elseif is_time_function(ex.Δ)
        Any[ex.Δ=>sum(put(ex.nsites, i => op) for i in 1:ex.nsites)]
    else
        error("unexpected type for Δ: $(typeof(ex.Δ))")
    end
end

function emit_dynamic_terms(ex::SumOfXPhaseTypes)
    op = (ex isa SumOfXPhase ? XPhase : (ex isa SumOfXPhase_01 ? XPhase_01 : XPhase_1r))
    op_u = (ex isa SumOfXPhase ? ConstGate.Pu : (ex isa SumOfXPhase_01 ? Pu_01 : Pu_1r))
    op_d = (ex isa SumOfXPhase ? ConstGate.Pd : (ex isa SumOfXPhase_01 ? Pd_01 : Pd_1r))
    T = typeof(ex)
    @switch (ex.Ω, ex.ϕ) begin
        @case (::Number, ::Number) || (::Vector{<:Number}, ::Vector{<:Number}) ||
            (::Number, ::Vector{<:Number}) || (::Vector{<:Number}, ::Number)
        return Any[one=>ex]

        # Ω time-dependent
        @case (Ω::Vector, ϕ::Number)
        return map(enumerate(Ω)) do (i, Ω_i)
            return Ω_i => put(ex.nsites, i => op(ϕ))
        end
        @case (Ω, ϕ::Number)
        return Any[Ω => T(ex.nsites, one(ϕ), ϕ)]

        @case (Ω::Vector, ϕ::Vector{<:Number})
        return map(enumerate(zip(Ω, ϕ))) do (i, (Ω_i, ϕ_i))
            return Ω_i => put(ex.nsites, i => op(ϕ_i))
        end
        @case (Ω, ϕ::Vector{<:Number})
        return Any[Ω => T(ex.nsites, one(eltype(ϕ)), ϕ)]

        # ϕ time-dependent
        @case (Ω::Number, ϕ::Vector)
        lhs = map(enumerate(ϕ)) do (i, ϕ_i)
            return (t -> exp(ϕ_i(t) * im)) => put(ex.nsites, i => Ω * op_u)
        end

        rhs = map(enumerate(ϕ)) do (i, ϕ_i)
            return (t -> exp(-ϕ_i(t) * im)) => put(ex.nsites, i => Ω * op_d)
        end
        return vcat(lhs, rhs)

        @case (Ω::Number, ϕ)
        return [
            (t -> exp(ϕ(t) * im)) => sum(put(ex.nsites, i => Ω * op_u) for i in 1:ex.nsites),
            (t -> exp(-ϕ(t) * im)) => sum(put(ex.nsites, i => Ω * op_d) for i in 1:ex.nsites),
        ]

        @case (Ω::Vector{<:Number}, ϕ::Vector)
        lhs = map(enumerate(zip(Ω, ϕ))) do (i, (Ω_i, ϕ_i))
            return (t -> exp(ϕ_i(t) * im)) => put(ex.nsites, i => Ω_i * op_u)
        end

        rhs = map(enumerate(zip(Ω, ϕ))) do (i, (Ω_i, ϕ_i))
            return (t -> exp(-ϕ_i(t) * im)) => put(ex.nsites, i => Ω_i * op_d)
        end
        return vcat(lhs, rhs)
        @case (Ω::Vector{<:Number}, ϕ)
        return [
            (t -> exp(ϕ(t) * im)) => sum(put(ex.nsites, i => Ω_i * op_u) for (i, Ω_i) in enumerate(Ω)),
            (t -> exp(-ϕ(t) * im)) => sum(put(ex.nsites, i => Ω_i * op_d) for (i, Ω_i) in enumerate(Ω)),
        ]

        # both time-dependent
        @case (Ω::Vector, ϕ::Vector)
        lhs = map(enumerate(zip(Ω, ϕ))) do (i, (Ω_i, ϕ_i))
            return (t -> Ω_i(t) * exp(ϕ_i(t) * im)) => put(ex.nsites, i => op_u)
        end

        rhs = map(enumerate(zip(Ω, ϕ))) do (i, (Ω_i, ϕ_i))
            return (t -> Ω_i(t) * exp(-ϕ_i(t) * im)) => put(ex.nsites, i => op_d)
        end
        return vcat(lhs, rhs)
        @case (Ω::Vector, ϕ)
        lhs = map(enumerate(Ω)) do (i, Ω_i)
            return (t -> Ω_i(t) * exp(ϕ(t) * im)) => put(ex.nsites, i => op_u)
        end

        rhs = map(enumerate(Ω)) do (i, Ω_i)
            return (t -> Ω_i(t) * exp(-ϕ(t) * im)) => put(ex.nsites, i => op_d)
        end
        return vcat(lhs, rhs)
        @case (Ω, ϕ::Vector)
        lhs = map(enumerate(ϕ)) do (i, ϕ_i)
            return (t -> Ω(t) * exp(ϕ_i(t) * im)) => put(ex.nsites, i => op_u)
        end

        rhs = map(enumerate(ϕ)) do (i, ϕ_i)
            return (t -> Ω(t) * exp(-ϕ_i(t) * im)) => put(ex.nsites, i => op_d)
        end
        return vcat(lhs, rhs)
        @case (Ω, ϕ)
        return [
            (t -> Ω(t) * exp(ϕ(t) * im)) => sum(put(ex.nsites, i => op_u) for i in 1:ex.nsites),
            (t -> Ω(t) * exp(-ϕ(t) * im)) => sum(put(ex.nsites, i => op_d) for i in 1:ex.nsites),
        ]
    end
end

emit_dynamic_terms(h::RydbergHamiltonian) = emit_dynamic_terms(add_terms(h))
emit_dynamic_terms(h::RydbergHamiltonian3) = emit_dynamic_terms(add_terms(h))

"""
    Hamiltonian(::Type{Tv}, expr[, space=fullspace])

Create a `Hamiltonian` from hamiltonian expr that has matrix element of type `Tv`.
"""
function Hamiltonian(::Type{Tv}, ex::AbstractBlock, space::AbstractSpace = fullspace) where {Tv}
    fs, ts = [], []
    const_term = nothing
    for (f, op) in emit_dynamic_terms(ex)
        if f === Base.one 
            const_term = isnothing(const_term) ? op : const_term + op
        elseif nthreads() > 1
            push!(fs, f)
            push!(ts, ThreadedMatrix(mat(Tv, op, space))) 
        else
            push!(fs, f)
            push!(ts, mat(Tv, op, space))
        end
    end
    push!(fs, Base.one)

    if !isnothing(const_term)
        if nthreads() > 1
            push!(ts, ThreadedMatrix(mat(Tv, const_term, space)))
        else
            push!(ts, mat(Tv, const_term, space))
        end
    end
    return Hamiltonian((fs...,), (ts...,))
end

function YaoBlocks.Optimise.to_basictypes(h::SumOfXTypes)
    is_const_param(h.Ω) || throw(ArgumentError("expect constant hamiltonian"))
    op = (h isa SumOfX ? X : (h isa SumOfX_01 ? X_01 : X_1r))
    return if h.Ω isa Vector
        sum(h.Ω[i] * put(h.nsites, i => op) for i in 1:h.nsites)
    else
        h.Ω * sum(put(h.nsites, i => op) for i in 1:h.nsites)
    end
end

function YaoBlocks.Optimise.to_basictypes(h::SumOfZAndNTypes)
    is_const_param(h.Δ) || throw(ArgumentError("expect constant hamiltonian"))
    op = if h isa SumOfN
        ConstGate.P1
    elseif h isa SumOfN_1
        N_1
    elseif h isa SumOfN_r
        N_r
    elseif h isa SumOfZ
        Z
    elseif h isa SumOfZ_01
        Z_01
    elseif h isa SumOfZ_1r
        Z_1r
    end
    return if h.Δ isa Vector
        sum(h.Δ[i] * put(h.nsites, i => op) for i in 1:h.nsites)
    else
        h.Δ * sum(put(h.nsites, i => op) for i in 1:h.nsites)
    end
end

function YaoBlocks.Optimise.to_basictypes(h::SumOfXPhaseTypes)
    is_const_param(h.Ω) || throw(ArgumentError("expect constant hamiltonian"))
    is_const_param(h.ϕ) || throw(ArgumentError("expect constant hamiltonian"))
    op = (h isa SumOfXPhase ? XPhase : (h isa SumOfXPhase_01 ? XPhase_01 : XPhase_1r))
    return @switch (h.Ω, h.ϕ) begin
        @case (::Vector, ::Vector)
        sum(h.Ω[i] * put(h.nsites, i => op(h.ϕ[i])) for i in 1:h.nsites)
        @case (Ω::Vector, ϕ)
        sum(Ω_i * put(h.nsites, i => op(ϕ)) for (i, Ω_i) in enumerate(Ω))
        @case (Ω, ϕ::Vector)
        sum(Ω * put(h.nsites, i => op(ϕ_i)) for (i, ϕ_i) in enumerate(ϕ))
        @case (Ω, ϕ)
        sum(Ω * put(h.nsites, i => op(ϕ)) for i in 1:h.nsites)
    end
end

function YaoBlocks.Optimise.to_basictypes(ex::RydInteract{D}) where D
    nsites = length(ex.atoms)
    V = rydberg_interaction_matrix(ex.atoms,ex.C)
    term = nothing
    op = (D == 2 ? ConstGate.P1 : N_r)
    for i in 1:nsites, j in i+1:nsites
        h = V[i,j]*kron(nsites, i => op, j => op)

        if isnothing(term)
            term = h
        else
            term += h
        end
    end
    term === nothing && return Add(nsites; nlevel = D)
    return term
end

function YaoBlocks.Optimise.to_basictypes(h::RydbergHamiltonian)
    return YaoBlocks.Optimise.simplify(add_terms(h); rules=[YaoBlocks.Optimise.to_basictypes])
end
function YaoBlocks.Optimise.to_basictypes(h::RydbergHamiltonian3)
    return YaoBlocks.Optimise.simplify(add_terms(h); rules=[YaoBlocks.Optimise.to_basictypes])
end


function emit_lowered(h)
    return YaoBlocks.Optimise.simplify(h; rules = [YaoBlocks.Optimise.to_basictypes])
end

module Lowlevel

using SparseArrays
using LuxurySparse
using SparseMatricesCSR
using Polyester
using Preferences
using Adapt
using LaTeXStrings
using LinearAlgebra
using ForwardDiff
using Base.Threads: nthreads


export Hamiltonian, SumOfLinop
export ThreadedMatrix
export set_backend
export storage_size, to_matrix
export precision_type, highest_type
export add_I, isskewhermitian

#export ValH, get_f # convert StepHamiltonian to ValHamiltonian

include("types.jl")
include("printings.jl")

## things related to low-level linalg of 4 data types:
#  1. PermMatrix
#  2. Diagonal
#  3. SparseMatrixCSC
#  4. SparseMatrixCSR
include("backends/Parallel/linalg_internal.jl")
include("backends/SingleThread/linalg_internal.jl")

include("linalg.jl")
include("preferences.jl")

end 

function Base.show(io::IO, ::MIME"text/plain", h::Hamiltonian)
    tab(n) = " "^(n + get(io, :indent, 0))
    println(io, tab(0), "Hamiltonian")
    println(io, tab(2), "number of dynamic terms: ", count(x -> x !== Base.one, h.fs))
    print(io, tab(2), "storage size: ")
    return print(io, Base.format_bytes(sum(sizeof, h.ts)))
end

#**************************************************************
#  Here, one can find the linalg API for  
#  1. Hamiltonian/SumOfLinop
#  2. Binding of standard LinearAlgebra functions 
#     to the backend of choice for ThreadedMatrix
#**************************************************************


## mul!
#--------------------------------
function LinearAlgebra.mul!(C::AbstractVecOrMat, A::SumOfLinop, B::AbstractVecOrMat)
    fill!(C, zero(eltype(C)))
    for (f, term) in zip(A.fvals, A.ts)
        mul!(C, term, B, f, one(f))
    end
    return C
end

## additionals, maybe we don't need this.

function Base.:*(a::Number,b::SumOfLinop)
    return SumOfLinop{RegularLinop}(b.fvals .* a, b.ts)
end

function Base.:*(a::Complex,b::SumOfLinop{T}) where {T}
    if real(a) ≈ 0
        return SumOfLinop{anti_type(T)}(b.fvals .* a, b.ts)
    elseif imag(a) ≈ 0
        return SumOfLinop{T}(b.fvals .* a, b.ts)
    else
        return SumOfLinop{RegularLinop}(b.fvals .* a, b.ts)
    end
end

function Base.:*(a::Real,b::SumOfLinop{T}) where {T}
    return SumOfLinop{T}(b.fvals .* a, b.ts)
end

Base.:*(n, m::T) where {T <: ThreadedMatrix} = n * m.matrix


#=
function Base.:+(a::SumOfLinop, b::SumOfLinop)
    if !(a.ts === b.ts)
        error("two SumOfLinop must share the same static terms ")
    end
    return SumOfLinop(a.fvals + b.fvals, a.ts)
end

function Base.:-(a::SumOfLinop, b::SumOfLinop)
    if !(a.ts === b.ts)
        error("two SumOfLinop must share the same static terms ")
    end
    return SumOfLinop(a.fvals - b.fvals, a.ts)
end
=#


# if BloqadeExpr was the backend of choice, then ThreadedMatrix will have the SparseMatrixCSC type
# in which case we just dispatch to standard mul!
LinearAlgebra.mul!(C, A::ThreadedMatrix{<:SparseMatrixCSC}, B, α, β) = SparseArrays.mul!(C, A.matrix, B, α, β) 

# if PMCSR/TSCSR was the backend of choice, then direct to bmul!'s below
LinearAlgebra.mul!(C, A::ThreadedMatrix, B, α, β) = bmul!(C, A.matrix, B, α, β)

##-------------------------------- mul!


## opnorm()
# --------------------------------
function LinearAlgebra.opnorm(h::SumOfLinop, p = 2)
    return opnorm(to_matrix(h), p)
end

##---------------------------------


## tr()
# --------------------------------
function LinearAlgebra.tr(A::SumOfLinop)
    return sum(zip(A.fvals, A.ts)) do (f, t)
        return f * tr(t)
    end
end

# [TODO] parallel trace (btrace)
# if BloqadeExpr was the backend of choice, then ThreadedMatrix will have the SparseMatrixCSC type
# in which case we just dispatch to single threaded tr
##LinearAlgebra.tr(C, A::ThreadedMatrix{<:SparseMatrixCSC}, B, α, β) = trace(A.matrix) 

# if PMCSR/TSCSR was the backend of choice, then direct to bmul!'s below
##LinearAlgebra.tr(C, A::ThreadedMatrix, B, α, β) = btrace(A.matrix)

## [NOTE] currently only single thread for trace is implemented, so we use the exposed LinearAlgebra.tr() 
#  that bind to trace()
LinearAlgebra.tr(A::ThreadedMatrix) = tr(A.matrix)

##--------------------------------  tr()


## check if is hermitian. 
# --------------------------------
LinearAlgebra.ishermitian(A::SumOfLinop{<: LinearAlgebra.Hermitian}) = true
LinearAlgebra.ishermitian(A::SumOfLinop) = false

isskewhermitian(A::SumOfLinop{<: SkewHermitian}) = true
isskewhermitian(A::SumOfLinop) = false


## adjoint() 
function LinearAlgebra.adjoint(A::SumOfLinop{<:LinearAlgebra.Hermitian})
    return A
end
function LinearAlgebra.adjoint(A::SumOfLinop{<:SkewHermitian})
    return SumOfLinop{SkewHermitian}(A.fvals.*(-1), A.ts)
end
function LinearAlgebra.adjoint(A::SumOfLinop{OPTYPE}) where {OPTYPE}
    return SumOfLinop{OPTYPE}(conj.(A.fvals), map(adjoint,A.ts))
end

## add constant identity term into SumOfLinop
# [NOTE] this does not check the type consistency of c w.r.t. A.fvals. 
function add_I(A,c::Number)
    Iop = LinearAlgebra.I(size(A,1))
    return A + c*Iop
end

function add_I(A::SumOfLinop, c::Number)
    Iop = LinearAlgebra.I(size(A,1))

    if nthreads() > 1
        return SumOfLinop{RegularLinop}((A.fvals...,c),(A.ts...,ThreadedMatrix(Iop)))
    else
        return SumOfLinop{RegularLinop}((A.fvals...,c),(A.ts...,Iop))
    end

end

function add_I(A::SumOfLinop{<:LinearAlgebra.Hermitian}, c::Real)
    # check backend:
    Iop = LinearAlgebra.I(size(A,1))

    if nthreads() > 1
        return SumOfLinop{LinearAlgebra.Hermitian}((A.fvals...,c),(A.ts...,ThreadedMatrix(Iop)))
    else
        return SumOfLinop{LinearAlgebra.Hermitian}((A.fvals...,c),(A.ts...,Iop))
    end

end
function add_I(A::SumOfLinop{<:LinearAlgebra.Hermitian}, c::Complex)
    # check backend:
    Iop = LinearAlgebra.I(size(A,1))

    OPTYPE=RegularLinop
    if imag(c) ≈ 0
        OPTYPE = LinearAlgebra.Hermitian
    end

    if nthreads() > 1
        return SumOfLinop{OPTYPE}((A.fvals...,c),(A.ts...,ThreadedMatrix(Iop)))
    else
        return SumOfLinop{OPTYPE}((A.fvals...,c),(A.ts...,Iop))
    end

end

function add_I(A::SumOfLinop{<:SkewHermitian}, c::Real)
    # check backend:
    Iop = LinearAlgebra.I(size(A,1))

    if nthreads() > 1
        return SumOfLinop{RegularLinop}((A.fvals...,c),(A.ts...,ThreadedMatrix(Iop)))
    else
        return SumOfLinop{RegularLinop}((A.fvals...,c),(A.ts...,Iop))
    end

end
function add_I(A::SumOfLinop{<:SkewHermitian}, c::Complex)
    # check backend:
    Iop = LinearAlgebra.I(size(A,1))

    OPTYPE=RegularLinop
    if real(c) ≈ 0
        OPTYPE = SkewHermitian
    end

    if nthreads() > 1
        return SumOfLinop{OPTYPE}((A.fvals...,c),(A.ts...,ThreadedMatrix(Iop)))
    else
        return SumOfLinop{OPTYPE}((A.fvals...,c),(A.ts...,Iop))
    end

end



## taking derivative of Hamiltonian and evaluate at time 
## H'(t)
## this returns a SumOfLinop with fvals being the derivative
#function derivative(h::Hamiltonian, t::Real)
#    return SumOfLinop{Hermitian}(ForwardDiff.derivative.(h.fs,t), h.ts)
#end

function derivative(h::Hamiltonian, t::Real)
    ## remove terms that are zero
    fvals = ForwardDiff.derivative.(h.fs,t)
    mask = collect(fvals .!= 0)
    return SumOfLinop{Hermitian}(fvals[mask],h.ts[mask])
end

using Test
using BloqadeExpr

atoms = [(1, 2), (2, 3)]

for h in [
    rydberg_h(atoms; Ω = 1.0, Δ = sin),
    rydberg_h(atoms; Ω = 1.0, Δ = [sin, sin]),
    rydberg_h(atoms; Ω = sin, Δ = 1.0),
    rydberg_h(atoms; Ω = [sin, sin], Δ = 1.0),
    rydberg_h(atoms; Ω = 2.0, Δ = sin),
    rydberg_h(atoms; Ω = 2.0, Δ = [sin, sin]),
    rydberg_h(atoms; Ω = sin, Δ = 2.0),
    rydberg_h(atoms; Ω = [sin, sin], Δ = 2.0),
    rydberg_h(atoms; Ω = [1.0, 2.0], Δ = sin),
    rydberg_h(atoms; Ω = [1.0, 2.0], Δ = [sin, sin]),
    rydberg_h(atoms; Ω = sin, Δ = [1.0, 2.0]),
    rydberg_h(atoms; Ω = [sin, sin], Δ = [1.0, 2.0]),
    rydberg_h(atoms; Ω = 1.0, ϕ = sin),
    rydberg_h(atoms; Ω = 1.0, ϕ = [sin, sin]),
    rydberg_h(atoms; Ω = sin, ϕ = 1.0),
    rydberg_h(atoms; Ω = [sin, sin], ϕ = 1.0),
    rydberg_h(atoms; Ω = 2.0, ϕ = sin),
    rydberg_h(atoms; Ω = 2.0, ϕ = [sin, sin]),
    rydberg_h(atoms; Ω = sin, ϕ = 2.0),
    rydberg_h(atoms; Ω = [sin, sin], ϕ = 2.0),
    rydberg_h(atoms; Ω = [1.0, 2.0], ϕ = sin),
    rydberg_h(atoms; Ω = [1.0, 2.0], ϕ = [sin, sin]),
    rydberg_h(atoms; Ω = sin, ϕ = [1.0, 2.0]),
    rydberg_h(atoms; Ω = [sin, sin], ϕ = [1.0, 2.0]),
]
    show(stdout, MIME"text/plain"(), h)
    println(stdout, "----------")
    println(stdout, "----------")
    show(stdout, MIME"text/latex"(), h)

    show(stdout, MIME"text/plain"(), Hamiltonian(ComplexF64, h))
end

params = [nothing, 1.0, [1.0, 2.0], sin, [sin, cos]]
for Ω_hf in params, ϕ_hf in params
    h = rydberg_h_3(atoms; Ω_hf, Δ_hf = 1.0, ϕ_hf, Ω_r = 1.0, Δ_r = 1.0, ϕ_r = 1.0)
    show(stdout, MIME"text/plain"(), h)
    println(stdout, "----------")
    println(stdout, "----------")
    show(stdout, MIME"text/latex"(), h)
    show(stdout, MIME"text/plain"(), Hamiltonian(ComplexF64, h))
end
for Δ_hf in params
    h = rydberg_h_3(atoms; Ω_hf = 1.0, Δ_hf, ϕ_hf = 1.0, Ω_r = 1.0, Δ_r = 1.0, ϕ_r = 1.0)
    show(stdout, MIME"text/plain"(), h)
    println(stdout, "----------")
    println(stdout, "----------")
    show(stdout, MIME"text/latex"(), h)
    show(stdout, MIME"text/plain"(), Hamiltonian(ComplexF64, h))
end
for Ω_r in params, ϕ_r in params
    h = rydberg_h_3(atoms; Ω_hf = 1.0, Δ_hf = 1.0, ϕ_hf = 1.0, Ω_r, Δ_r = 1.0, ϕ_r)
    show(stdout, MIME"text/plain"(), h)
    println(stdout, "----------")
    println(stdout, "----------")
    show(stdout, MIME"text/latex"(), h)
    show(stdout, MIME"text/plain"(), Hamiltonian(ComplexF64, h))
end
for Δ_r in params
    h = rydberg_h_3(atoms; Ω_hf = 1.0, Δ_hf = 1.0, ϕ_hf = 1.0, Ω_r = 1.0, Δ_r, ϕ_r = 1.0)
    show(stdout, MIME"text/plain"(), h)
    println(stdout, "----------")
    println(stdout, "----------")
    show(stdout, MIME"text/latex"(), h)
    show(stdout, MIME"text/plain"(), Hamiltonian(ComplexF64, h))
end

for op in (SumOfZ, SumOfZ_01, SumOfZ_1r), p in params
    h = op(2, isnothing(p) ? 0 : p)
    println(stdout, "\n")
    show(stdout, MIME"text/plain"(), h)
    println("")
    show(stdout, MIME"text/latex"(), h)
    println(stdout, "\n----------")
    println(stdout, "----------")
    show(stdout, MIME"text/plain"(), Hamiltonian(ComplexF64, h))
end

using Test
using BloqadeExpr
using LinearAlgebra
using Random
using LuxurySparse
using BloqadeExpr: Hamiltonian

atoms = [(1, 1), (1, 2), (1, 3), (1, 4), (1, 5)]
h = rydberg_h(atoms; Ω = 1.0, Δ = sin)

hlist = Hamiltonian(Float64, h)


@testset "add_I for SumOfLinop" begin

    Ht = hlist(0.1)

    @test ishermitian(Ht)
    # these values are not mutated and can be re-used throughout the unit tests
    H1 = add_I(Ht, -0.5)
    H2 = add_I(Ht, -0.5+1im)
    H3 = add_I(Ht, 0.5im)

    @test ishermitian(H1) == true
    @test isskewhermitian(H1) == false

    @test ishermitian(H2) == false
    @test isskewhermitian(H2) == false

    @test ishermitian(H3) == false
    @test isskewhermitian(H3) == false


    Ha = 1.0im*Ht

    @test ishermitian(Ha) == false
    @test isskewhermitian(Ha) == true

    H1a = add_I(Ha, -0.5)
    H2a = add_I(Ha, -0.5+1im)
    H3a = add_I(Ha, 0.5im)   

    @test ishermitian(H1a) == false
    @test isskewhermitian(H1a) == false

    @test ishermitian(H2a) == false
    @test isskewhermitian(H2a) == false

    @test ishermitian(H3a) == false
    @test isskewhermitian(H3a) == true




    M = to_matrix(Ht)
    S = add_I(M, 1+3.)
    @test S == M + (1+3.)*LinearAlgebra.I(size(M,1))   



    
end

using Test
using BloqadeExpr
using LinearAlgebra
using Random
using LuxurySparse
using BloqadeExpr: Hamiltonian




@testset "derivative for Hamiltonain" begin

    atoms = [(1, 1)]
    h = rydberg_h(atoms; Ω = 1.0, Δ = sin)
    hlist = Hamiltonian(Float64, h)

    h2 = rydberg_h(atoms; Ω = 0.0,  Δ = cos)
    htar = Hamiltonian(Float64, h2)

    println(htar.ts)
    println(hlist.ts)

    for t in 0:0.1:2
        src = derivative(hlist, t)
        tar = htar(t)

        @test to_matrix(src) == to_matrix(tar)
    
    end


    
end

using Test
using Random
using YaoBlocks
using BloqadeExpr
using Yao
using SparseArrays

@testset "mat" begin
    ss = Subspace(10, sort(randperm(1023)[1:100]))
    U = zeros(ComplexF64, 1024, 1024)
    U[ss, ss] = rand_unitary(length(ss))
    H = U * U'
    for g in [
        put(10, 2 => X),
        put(10, 3 => Rx(0.4)),
        put(10, 2:6 => matblock(rand_unitary(32))) * 2,
        control(10, (3, -5), (2, 7) => matblock(rand_unitary(4))),
        chain(matblock(U), matblock(U)),
        igate(10),
        subroutine(10, kron(X, X), (5, 2)),
        control(10, (3, -5), (2, 7) => matblock(rand_unitary(4)))',
        put(10, 2 => X) + matblock(rand_unitary(1024)),
        time_evolve(matblock(H), 0.3),
    ]
        M = SparseMatrixCSC(mat(g))[ss, ss]
        @test M ≈ mat(g, ss)
    end
end

@testset "XPhase = PdPhase + PuPhase" begin
    @test mat(XPhase(1.0)) ≈ mat(PdPhase(1.0)) + mat(PuPhase(1.0))
end

@testset "Int128" begin
    h = rydberg_h([(rand(2) .* 10...,) for i=1:66], 0.2, 0.3, 0.3, 0.6)
    s = Subspace(127, rand(Int128, 100) .>> 1)
    @test mat(h, s) isa SparseMatrixCSC
end

@testset "3-level operators" begin
    ids_r = [5, 6, 8, 9]
    ids_hf = [1, 2, 4, 5]

    SX_r = mat(SumOfX_1r(2))
    @test isapprox(SX_r[ids_r, ids_r], mat(SumOfX(2)))
    SX_hf = mat(SumOfX_01(2))
    @test SX_hf[ids_hf, ids_hf] ≈ mat(SumOfX(2))
    SZ_r = mat(SumOfZ_1r(2))
    @test SZ_r[ids_r, ids_r] ≈ mat(SumOfZ(2))
    SZ_hf = mat(SumOfZ_01(2))
    @test SZ_hf[ids_hf, ids_hf] ≈ mat(SumOfZ(2))
    SN_r = mat(SumOfN_r(2))
    @test SN_r[ids_r, ids_r] ≈ mat(SumOfN(2))
    SN_hf = mat(SumOfN_1(2))
    @test SN_hf[ids_hf, ids_hf] ≈ mat(SumOfN(2))

    SXPhase_r = mat(SumOfXPhase_1r(2, 1, [0, 0]))
    @test SX_r ≈ SXPhase_r
    
    ϕ = rand()*2π
    @test mat(PuPhase_1r(ϕ)) + mat(PdPhase_1r(ϕ)) ≈ mat(XPhase_1r(ϕ))
    @test mat(PuPhase_01(ϕ)) + mat(PdPhase_01(ϕ)) ≈ mat(XPhase_01(ϕ))
    @test sum(mat.([Pu_1r, Pd_1r, Pu_01, Pd_01])) ≈ [0 1 0; 1 0 1; 0 1 0]
end

using Test
using BloqadeExpr
using YaoBlocks
using BloqadeExpr: emit_dynamic_terms, emit_lowered, Hamiltonian, to_matrix, XPhase, PuPhase, PdPhase

@testset "emit_lowered" begin
    @test emit_lowered(SumOfX(5, 0.1)) == 0.1 * sum(put(5, i => X) for i in 1:5)
    @test emit_lowered(SumOfN(5, 0.1)) == 0.1 * sum(put(5, i => ConstGate.P1) for i in 1:5)
    @test emit_lowered(SumOfZ(5, 0.1)) == 0.1 * sum(put(5, i => Z) for i in 1:5)
    @test emit_lowered(SumOfXPhase(5, 0.1, 0.2)) == sum(0.1 * put(5, i => XPhase(0.2)) for i in 1:5)
end

atoms = [(1, 1), (1, 2), (1, 3)]
params = [nothing, 1.0, 2.0, [0.1 for _ in 1:3], sin, [sin for _ in 1:3], cos]
@testset "emit_dynamic_terms (2-level)" begin
    @testset "Ω=$Ω" for Ω in params
        @testset "Δ=$Δ" for Δ in params
            @testset "ϕ=$ϕ" for ϕ in params
                h = rydberg_h(atoms; Ω, Δ, ϕ)
                H = Hamiltonian(ComplexF64, h)
                @test to_matrix(H(0.1)) ≈ mat(ComplexF64, h |> attime(0.1))
            end
        end
    end
end;

nsites = 3
atoms = [(1, i) for i = 1:nsites]
params = [nothing, 1.0, [0.1 for _ in 1:nsites], sin, [sin for _ in 1:nsites]]
@testset "emit_dynamic_terms (3-level)" begin
    @testset "Ω_hf=$Ω_hf, Δ_hf=$Δ_hf, ϕ_hf=$ϕ_hf" for Ω_hf in params[2:2], Δ_hf in params[3:4], ϕ_hf in params[5:5]
        @testset "Ω_r=$Ω_r, Δ_r=$Δ_r, ϕ_r=$ϕ_r" for Ω_r in params[2:end], Δ_r in params, ϕ_r in params
            h = rydberg_h_3(atoms; Ω_hf, Δ_hf, ϕ_hf, Ω_r, Δ_r, ϕ_r)
            H = Hamiltonian(ComplexF64, h)
            @test to_matrix(H(0.1)) ≈ mat(ComplexF64, h |> attime(0.1))
        end
    end
    @testset "SumOfZ_01, SumOfZ_1r" for a in params, b in params
        h = SumOfZ_01(nsites, isnothing(a) ? 0.0 : a) + SumOfZ_1r(nsites, isnothing(b) ? 0.0 : b)
        H = Hamiltonian(ComplexF64, h)
        @test to_matrix(H(0.1)) ≈ mat(ComplexF64, h |> attime(0.1))
    end
end;

using Test
using BloqadeExpr


if "docstring" in ARGS
    # include("docstrings.jl")
    exit()
end


@testset "linear algebra on derivative of H" begin
    include("linalg_derivative.jl")
end


@testset "linear algebra on linear map: mul!()" begin
    include("linalg_mul.jl")
end

@testset "linear algebra on trace: tr()" begin
    include("linalg_tr.jl")
end


@testset "linear algebra add_I()" begin
    include("linalg_addI.jl")
end


@testset "assertions" begin
    include("assert.jl")
end

@testset "interfaces" begin
    include("interface.jl")
end

@testset "types" begin
    include("types.jl")
end

@testset "lower" begin
    include("lower.jl")
end



@testset "matrix construction" begin
    include("mat.jl")
end

@testset "space" begin
    include("space.jl")
end

@testset "units" begin
    include("units.jl")
end

@testset "atoms" begin
    include("atoms.jl")
end

@testset "printings" begin
    include("printings.jl")
end

# @testset "3-level supports" begin
#     include("3-level_supports.jl")
# end

using Test
using BloqadeExpr
using YaoBlocks
using YaoBlocks.Optimise
using BloqadeLattices


@testset "process_atom_positions" begin
    position = [(1, 2), (2, 3)]
    lattice = parallelepiped_region(SquareLattice(),(0,2),(2,0);scale=5)
    @test BloqadeExpr.process_atom_positions(position) == position
    @test BloqadeExpr.process_atom_positions(lattice) == lattice
    
end

@testset "rydberg_h" begin
    atom_list = [(1, 2), (2, 3)]
    lattice = parallelepiped_region(ChainLattice(),(2,);scale=5)

    for positions in [atom_list,lattice]
        h = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = 0.5)
        @test BloqadeExpr.add_terms(rydberg_h(positions; Ω = 1.0)) == Optimise.simplify(h)

        h = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = 0.5) - SumOfN(; nsites = 2, Δ = 0.2)
        @test BloqadeExpr.add_terms(rydberg_h(positions; Ω = 1.0, Δ = 0.2)) == Optimise.simplify(h)

        h = RydInteract(; atoms = positions) + SumOfXPhase(; nsites = 2, Ω = 0.5, ϕ = 0.1) - SumOfN(; nsites = 2, Δ = 0.2)
        @test BloqadeExpr.add_terms(rydberg_h(positions; Ω = 1.0, ϕ = 0.1, Δ = 0.2)) == Optimise.simplify(h)

        h = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = [2.0, 1.0])
        @test BloqadeExpr.add_terms(rydberg_h(positions; Ω = [4.0, 2.0])) == Optimise.simplify(h)
    end

end

@testset "rydberg_h_3" begin
    atom = [(0.0, 0.0)]
    params = [0.0, pi/2, nothing]
    n_to_0(x) = isnothing(x) ? 0.0 : x
    for Ω_hf in params, ϕ_hf in params, Δ_hf in params, Ω_r in params, ϕ_r in params, Δ_r in params
        h = rydberg_h_3(atom; Ω_hf, ϕ_hf, Δ_hf, Ω_r, ϕ_r, Δ_r)
        m = zeros(ComplexF64, 3, 3)
        Ω_hf, ϕ_hf, Δ_hf, Ω_r, ϕ_r, Δ_r = n_to_0.([Ω_hf, ϕ_hf, Δ_hf, Ω_r, ϕ_r, Δ_r])
        m[1, 2] = Ω_hf/2*exp(im*ϕ_hf)
        m[2, 1] = Ω_hf/2*exp(-im*ϕ_hf)
        m[2, 2] = -Δ_hf
        m[2, 3] = Ω_r/2*exp(im*ϕ_r)
        m[3, 2] = Ω_r/2*exp(-im*ϕ_r)
        m[3, 3] = -Δ_hf - Δ_r
        @test BloqadeExpr.mat(h) ≈ m
    end
end

@testset "attime" begin
    positions = [(1, 2), (2, 3)]
    h1 = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = sin)
    h2 = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = sin(0.1))
    @test isreal(h1)
    @test isreal(h2)
    @test h1 |> attime(0.1) == h2

    h1 = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = sin) - SumOfN(; nsites = 2, Δ = cos)
    h2 = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = sin(0.1)) - SumOfN(; nsites = 2, Δ = cos(0.1))
    @test h1 |> attime(0.1) == h2

    h1 = RydInteract(; atoms = positions) + SumOfXPhase(; nsites = 2, Ω = 0.5, ϕ = cos) - SumOfN(; nsites = 2, Δ = 0.2)
    h2 =
        RydInteract(; atoms = positions) + SumOfXPhase(; nsites = 2, Ω = 0.5, ϕ = cos(0.1)) -
        SumOfN(; nsites = 2, Δ = 0.2)
    @test !isreal(h1)
    @test h1 |> attime(0.1) == h2

    h1 = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = [sin, cos])
    h2 = RydInteract(; atoms = positions) + SumOfX(; nsites = 2, Ω = [sin(0.1), cos(0.1)])
    @test h1 |> attime(0.1) == h2
end


@testset "get_rydberg_params" begin
    atoms = [(i,i) for i in 1:10]

    values = [nothing,1,t->t^2,rand(10),[t->rand()*t for i in 1:10]]

    for ϕ in values, Ω in values, Δ in values
        h = rydberg_h(atoms,ϕ=ϕ,Ω=Ω,Δ=Δ)
        # catches the this weird edge case 
        Ω = (isnothing(Ω) && !isnothing(ϕ) ? 0 : Ω)
        @test (atoms=atoms,ϕ=ϕ,Ω=Ω,Δ=Δ) == get_rydberg_params(h)
    end
end

# Parallelized Permutation Matrix multiplication
function bmul!(C::AbstractVector, A::PermMatrix, B::AbstractVector, α::Number, β::Number)

    A_vals = A.vals
    A_perm = A.perm
    @batch for i in eachindex(B)
        perm_mul!(C, A_vals, A_perm, B, α, β, i)
    end
    return C
end
@inline function perm_mul!(C, A_vals, A_perm, B, α, β, i)
    @inbounds C[i] = A_vals[i] * B[A_perm[i]] * α + β * C[i]
end

# Parallelized Diagonal multiplication
function bmul!(C, A::Diagonal, B, α, β)
    d = A.diag
    @batch for i in eachindex(B)
        @inbounds C[i] = d[i] * B[i] * α + β * C[i] 
    end
    return C
end


# Taken directly from ThreadedSparseCSR. ThreadedSparseCSR currently only works with Polyester 0.5, which
# has known issues with thread count > 64. Moving it here allows us to support more recent versions of
# Polyester.
"""
    bmul!(y::AbstractVector, A::SparseMatrixCSR, x::AbstractVector, alpha::Number, beta::Number)
    bmul!(y::AbstractVector, A::SparseMatrixCSR, x::AbstractVector)
Evaluates `y = alpha*A*x + beta*y` (`y = A*x`)
In-place multithreaded version of sparse csr matrix - vector multiplication, using the threading provided by Polyester.jl
"""
function bmul!(y::AbstractVector, A::SparseMatrixCSR, x::AbstractVector, alpha::Number, beta::Number)
    
    A.n == size(x, 1) || throw(DimensionMismatch())
    A.m == size(y, 1) || throw(DimensionMismatch())

    o = getoffset(A)
    
    @batch minbatch = size(y, 1) ÷ nthreads() for row in 1:size(y, 1)
        @inbounds begin
            accu = zero(eltype(y))
            for nz in nzrange(A, row)
                col = A.colval[nz] + o
                accu += A.nzval[nz]*x[col]
            end
            y[row] = alpha*accu + beta*y[row]
    
        end
    end

    return y

end

module BloqadeExpr

using SparseArrays
using LinearAlgebra
using Adapt
using YaoAPI
using YaoBlocks
using LuxurySparse
using SparseMatricesCSR
using Base.Threads: nthreads
using MLStyle
using BitBasis
using LaTeXStrings
using Unitful: Quantity, NoUnits, MHz, µm, uconvert
using InteractiveUtils: subtypes
using Base.Cartesian: @nexprs
using YaoBlocks: ChainBlock, PutBlock, TrivialGate, Subroutine, Scale, Daggered, Add, ControlBlock, TimeEvolution
using BloqadeLattices: BoundedLattice, rydberg_interaction_matrix


include("Lowlevel/Lowlevel.jl")

using .Lowlevel: Hamiltonian, SumOfLinop, ThreadedMatrix, storage_size, to_matrix, precision_type, highest_type, add_I, derivative, RegularLinop, isskewhermitian


export rydberg_h,
    rydberg_h_3,
    FullSpace,
    Subspace,
    fullspace,
    RydInteract,
    SumOfX, SumOfX_01, SumOfX_1r,
    SumOfXPhase, SumOfXPhase_01, SumOfXPhase_1r,
    SumOfZ, SumOfZ_01, SumOfZ_1r,
    SumOfN, SumOfN_1, SumOfN_r,
    XPhase, XPhase_01, XPhase_1r,
    PdPhase, PdPhase_01, PdPhase_1r,
    PuPhase, PuPhase_01, PuPhase_1r,
    X_01, X_1r,
    N_1, N_r,
    Pu_01, Pu_1r,
    Pd_01, Pd_1r,
    RydbergHamiltonian, RydbergHamiltonian3,
    get_rydberg_params,
    Op,
    attime,
    matrix_to_positions,
    storage_size,
    emulate!,
    precision_type,
    highest_type,

    to_matrix,
    add_I,
    derivative,
    RegularLinop,  # abstype
    SkewHermitian, # abstype
    isskewhermitian


include("assert.jl")
include("space.jl")
include("types.jl")
include("printings.jl")
include("mat.jl")


include("lower.jl")
include("units.jl")


include("interface.jl")
include("atoms.jl")


end

YaoBlocks.print_block(io::IO, t::AbstractTerm) = print_expr(io, MIME"text/plain"(), t)
YaoBlocks.print_block(io::IO, t::RydbergHamiltonian) = print_expr(io, MIME"text/plain"(), t)
YaoBlocks.print_block(io::IO, t::XPhase) = print(io, "XPhase(", t.ϕ, ")")

Base.show(io::IO, ::Union{MIME"text/latex",MIME"application/x-latex"}, t::AbstractTerm) =
    print(io, latexstring(latex_expr(t)))
Base.show(io::IO, ::Union{MIME"text/latex",MIME"application/x-latex"}, t::RydbergHamiltonian) =
    print(io, latexstring(latex_expr(t)))
Base.show(io::IO, ::Union{MIME"text/latex",MIME"application/x-latex"}, t::Add) = print(io, latexstring(latex_expr(t)))

function latex_expr(t::Add)
    tex = latex_expr(t.list[1])

    for idx in 2:length(t.list)
        blk = t.list[idx]

        if blk isa Scale
            alpha = factor(blk)
            blk = content(blk)
            if alpha == -1
                tex *= "-"
            else
                tex = string(tex, "+", alpha, "\\cdot")
            end
        else
            tex = string(tex, "+")
        end
        tex = string(tex, latex_expr(blk))
    end
    return tex
end

function latex_expr(t::YaoBlocks.Scale)
    if isone(factor(t))
        latex_expr(content(t))
    else
        string(factor(t), "\\cdot", latex_expr(content(t)))
    end
end

function print_expr(io::IO, ::MIME"text/plain", t::RydInteract{D}) where D
    C = t.C / 2π
    n = ceil(log10(C))-1
    C = round(C / 10^n, digits = 3)
    str_op = (D == 2 ? "n_i n_j" : "n^r_i n^r_j")
    return print(io, "∑ 2π ⋅ $(C)e$n/|x_i-x_j|^6 ", str_op)
end

function latex_expr(t::RydInteract{D}) where D
    C = t.C / 2π
    n = ceil(log10(C))
    C = round(C / 10^n, digits = 3)
    str_op = (D == 2 ? "n_i n_j" : "n^r_i n^r_j")
    return "\\sum \\frac{2π \\cdot $C\\times 10^{$n}}{|x_i-x_j|^6} " * str_op
end

function pretty_number(x)
    return if isone(x)
        ""
    elseif isone(x / 2π)
        "2π ⋅ "
    else
        x = round(x / 2π, sigdigits = 3)
        "2π ⋅ $x ⋅ "
    end
end

function print_expr(io::IO, ::MIME"text/plain", t::SumOfXTypes)
    op = (t isa SumOfX ? "σ^x_i" : (t isa SumOfX_01 ? "σ^{x,hf}_i" : "σ^{x,r}_i"))
    if t.Ω isa Number
        print(io, pretty_number(t.Ω), "∑ ", op)
    elseif t.Ω isa Vector
        print(io, "∑ Ω_i ⋅ ", op)
    else
        print(io, "Ω(t) ⋅ ∑ ", op)
    end
end

function latex_expr(t::SumOfXTypes)
    op = (t isa SumOfX ? "σ^x_i" : (t isa SumOfX_01 ? "σ^{x,hr}_i" : "σ^{x,r}_i"))
    if t.Ω isa Number
        tex = pretty_number(t.Ω) * "\\sum " * op
    elseif t.Ω isa Vector
        tex = "\\sum Ω_i ⋅ " * op
    else
        tex = "Ω(t) ⋅ \\sum " * op
    end
    return tex
end

function print_expr(io::IO, ::MIME"text/plain", t::Union{SumOfN, SumOfN_1, SumOfN_r, SumOfZ, SumOfZ_01, SumOfZ_1r})
    op = if t isa SumOfN
        "n_i"
    elseif t isa SumOfN_1 
        "n^{hf}_i"
    elseif t isa SumOfN_r 
        "n^r_i"
    elseif t isa SumOfZ
        "σ^z_i"
    elseif t isa SumOfZ_01
        "σ^{z,hf}_i"
    elseif t isa SumOfZ_1r
        "σ^{z,r}_i"
    end
    if t.Δ isa Number
        print(io, pretty_number(t.Δ), "∑ $op")
    elseif t.Δ isa Vector
        print(io, "∑ Δ_i ⋅ $op")
    else
        print(io, "Δ(t) ⋅ ∑ $op")
    end
end

function latex_expr(t::Union{SumOfN, SumOfN_1, SumOfN_r, SumOfZ, SumOfZ_01, SumOfZ_1r}) 
    op = if t isa SumOfN
        "n_i"
    elseif t isa SumOfN_1 
        "n^{hf}_i"
    elseif t isa SumOfN_r 
        "n^r_i"
    elseif t isa SumOfZ
        "σ^z_i"
    elseif t isa SumOfZ_01
        "σ^{z,hf}_i"
    elseif t isa SumOfZ_1r
        "σ^{z,r}_i"
    end
    if t.Δ isa Number
        tex = pretty_number(t.Δ) * "\\sum $op"
    elseif t.Δ isa Vector
        tex = "\\sum Δ_i ⋅ $op"
    else
        tex = "Δ(t) ⋅ \\sum $op"
    end
    return tex
end

function print_expr(io::IO, ::MIME"text/plain", t::SumOfXPhaseTypes)
    if t isa SumOfXPhase
        @switch (t.Ω, t.ϕ) begin
            @case (Ω::Vector, ϕ::Vector)
            Ω = is_const_param(Ω) ? "Ω_i" : "Ω(t)_i"
            ϕ = is_const_param(ϕ) ? "ϕ_i" : "ϕ(t)_i"
            print(io, "∑ $Ω ⋅ (e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|)")
            @case (Ω::Vector, ϕ)
            Ω = is_const_param(Ω) ? "Ω_i" : "Ω(t)_i"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ(t)"
            print(io, "∑ $Ω ⋅ (e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|)")
            @case (Ω, ϕ::Vector)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω(t) ⋅"
            ϕ = is_const_param(ϕ) ? "ϕ_i" : "ϕ(t)_i"
            print(io, Ω, "∑ e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|")
            @case (Ω, ϕ)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω(t) ⋅"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ(t)"
            print(io, Ω, "∑ e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|")
        end
    elseif t isa SumOfXPhase_01
        @switch (t.Ω, t.ϕ) begin
            @case (Ω::Vector, ϕ::Vector)
            Ω = is_const_param(Ω) ? "Ω^{hf}_i" : "Ω^{hf}(t)_i"
            ϕ = is_const_param(ϕ) ? "ϕ^{hf}_i" : "ϕ^{hf}(t)_i"
            print(io, "∑ $Ω ⋅ (e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|)")
            @case (Ω::Vector, ϕ)
            Ω = is_const_param(Ω) ? "Ω^{hf}_i" : "Ω^{hf}(t)_i"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ^{hf}(t)"
            print(io, "∑ $Ω ⋅ (e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|)")
            @case (Ω, ϕ::Vector)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω^{hf}(t) ⋅"
            ϕ = is_const_param(ϕ) ? "ϕ^{hf}_i" : "ϕ^{hf}(t)_i"
            print(io, Ω, "∑ e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|")
            @case (Ω, ϕ)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω^{hf}(t) ⋅"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ^{hf}(t)"
            print(io, Ω, "∑ e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|")
        end
    elseif t isa SumOfXPhase_1r
        @switch (t.Ω, t.ϕ) begin
            @case (Ω::Vector, ϕ::Vector)
            Ω = is_const_param(Ω) ? "Ω^r_i" : "Ω^r(t)_i"
            ϕ = is_const_param(ϕ) ? "ϕ^r_i" : "ϕ^r(t)_i"
            print(io, "∑ $Ω ⋅ (e^{$ϕ ⋅ im} |1⟩⟨r| + e^{-$ϕ ⋅ im} |r⟩⟨1|)")
            @case (Ω::Vector, ϕ)
            Ω = is_const_param(Ω) ? "Ω^r_i" : "Ω^r(t)_i"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ^r(t)"
            print(io, "∑ $Ω ⋅ (e^{$ϕ ⋅ im} |1⟩⟨r| + e^{-$ϕ ⋅ im} |r⟩⟨1|)")
            @case (Ω, ϕ::Vector)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω^r(t) ⋅"
            ϕ = is_const_param(ϕ) ? "ϕ^r_i" : "ϕ^r(t)_i"
            print(io, Ω, "∑ e^{$ϕ ⋅ im} |1⟩⟨r| + e^{-$ϕ ⋅ im} |r⟩⟨1|")
            @case (Ω, ϕ)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω^r(t) ⋅"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ^r(t)"
            print(io, Ω, "∑ e^{$ϕ ⋅ im} |1⟩⟨r| + e^{-$ϕ ⋅ im} |r⟩⟨1|")
        end
    end
end

function latex_expr(t::SumOfXPhaseTypes)
    if t isa SumOfXPhase
        @switch (t.Ω, t.ϕ) begin
            @case (Ω::Vector, ϕ::Vector)
            Ω = is_const_param(Ω) ? "Ω_i" : "Ω(t)_i"
            ϕ = is_const_param(ϕ) ? "ϕ_i" : "ϕ(t)_i"
            tex = "\\sum $Ω ⋅ (e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|)"
            @case (Ω::Vector, ϕ)
            Ω = is_const_param(Ω) ? "Ω_i" : "Ω(t)_i"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ(t)"
            tex = "\\sum $Ω ⋅ (e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|)"
            @case (Ω, ϕ::Vector)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω(t) ⋅ "
            ϕ = is_const_param(ϕ) ? "ϕ_i" : "ϕ(t)_i"
            tex = Ω * "\\sum e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|"
            @case (Ω, ϕ)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω(t) ⋅ "
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ(t)"
            tex = Ω * "\\sum e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|"
        end
    elseif t isa SumOfXPhase_01
        @switch (t.Ω, t.ϕ) begin
            @case (Ω::Vector, ϕ::Vector)
            Ω = is_const_param(Ω) ? "Ω^{hf}_i" : "Ω^{hf}(t)_i"
            ϕ = is_const_param(ϕ) ? "ϕ^{hf}_i" : "ϕ^{hf}(t)_i"
            tex = "\\sum $Ω ⋅ (e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|)"
            @case (Ω::Vector, ϕ)
            Ω = is_const_param(Ω) ? "Ω^{hf}_i" : "Ω^{hf}(t)_i"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ^{hf}(t)"
            tex = "\\sum $Ω ⋅ (e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|)"
            @case (Ω, ϕ::Vector)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω^{hf}(t) ⋅ "
            ϕ = is_const_param(ϕ) ? "ϕ^{hf}_i" : "ϕ^{hf}(t)_i"
            tex = Ω * "\\sum e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|"
            @case (Ω, ϕ)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω^{hf}(t) ⋅ "
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ^{hf}(t)"
            tex = Ω * "\\sum e^{$ϕ ⋅ im} |0⟩⟨1| + e^{-$ϕ ⋅ im} |1⟩⟨0|"
        end
    elseif t isa SumOfXPhase_1r
        @switch (t.Ω, t.ϕ) begin
            @case (Ω::Vector, ϕ::Vector)
            Ω = is_const_param(Ω) ? "Ω^r_i" : "Ω^r(t)_i"
            ϕ = is_const_param(ϕ) ? "ϕ^r_i" : "ϕ^r(t)_i"
            tex = "\\sum $Ω ⋅ (e^{$ϕ ⋅ im} |1⟩⟨r| + e^{-$ϕ ⋅ im} |r⟩⟨1|)"
            @case (Ω::Vector, ϕ)
            Ω = is_const_param(Ω) ? "Ω^r_i" : "Ω^r(t)_i"
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ^r(t)"
            tex = "\\sum $Ω ⋅ (e^{$ϕ ⋅ im} |1⟩⟨r| + e^{-$ϕ ⋅ im} |r⟩⟨1|)"
            @case (Ω, ϕ::Vector)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω^r(t) ⋅ "
            ϕ = is_const_param(ϕ) ? "ϕ^r_i" : "ϕ^r(t)_i"
            tex = Ω * "\\sum e^{$ϕ ⋅ im} |1⟩⟨r| + e^{-$ϕ ⋅ im} |r⟩⟨1|"
            @case (Ω, ϕ)
            Ω = is_const_param(Ω) ? pretty_number(Ω) : "Ω^r(t) ⋅ "
            ϕ = is_const_param(ϕ) ? round(ϕ, sigdigits = 3) : "ϕ^r(t)"
            tex = Ω * "\\sum e^{$ϕ ⋅ im} |1⟩⟨r| + e^{-$ϕ ⋅ im} |r⟩⟨1|"
        end
    end
    return tex
end

function latex_expr(h::Union{RydbergHamiltonian, RydbergHamiltonian3})
    return latex_expr(add_terms(h))
end

function print_expr(io::IO, ::MIME"text/plain", h::Union{RydbergHamiltonian, RydbergHamiltonian3})
    print(io,add_terms(h))
end

module Op

using YaoBlocks
const n = YaoBlocks.ConstGate.P1

end

process_atom_positions(atom_positions::BoundedLattice) = atom_positions

function process_atom_positions(atom_positions) # catches other cases
    return map(atom_positions) do pos
        (pos...,)
    end
end

"""
    emulate!(prob)

Run emulation of a given problem.
"""
function emulate! end

"""
    rydberg_h(atoms; [C=2π * 862690 * MHz*µm^6], Ω[, ϕ, Δ])

Create a rydberg hamiltonian

```math
∑ \\frac{C}{|x_i - x_j|^6} n_i n_j + \\frac{Ω}{2} σ_x - Δ σ_n
```

shorthand for

```julia
RydInteract(C, atoms) + SumOfXPhase(length(atoms), Ω, ϕ) - SumOfN(length(atoms), Δ)
```

# Arguments

- `atoms`: a collection of atom positions.

# Keyword Arguments

- `C`: optional, default unit is `MHz*µm^6`, interation parameter,
    see also [`RydInteract`](@ref).
- `Ω`: optional, default unit is `MHz`, Rabi frequencies, divided by 2, see also [`SumOfX`](@ref).
- `Δ`: optional, default unit is `MHz`, detuning parameter, see [`SumOfN`](@ref).
- `ϕ`: optional, does not have unit, the phase, see [`SumOfXPhase`](@ref).

!!! tips
    The rabi frequencies are divided by two in the Rydberg hamiltonian unlike
    directly constructing via [`SumOfX`](@ref) or [`SumOfXPhase`](@ref).

!!! tips

    The parameters of Hamiltonian have their own default units to match hardware,
    one can use [`Unitful.jl`](https://github.com/PainterQubits/Unitful.jl)
    to specify their units explicitly. If the units are specified explicitly,
    they will be converted to default units automatically.

# Example

```julia-repl
julia> using Bloqade

julia> atoms = [(1, ), (2, ), (3, ), (4, )]
4-element Vector{Tuple{Int64}}:
 (1,)
 (2,)
 (3,)
 (4,)

julia> rydberg_h(atoms)
∑ 5.42e6/|x_i-x_j|^6 n_i n_j
```

```julia-repl
julia> rydberg_h(atoms; Ω=0.1)
nqubits: 4
+
├─ ∑ 5.42e6/|x_i-x_j|^6 n_i n_j
└─ 0.05 ⋅ ∑ σ^x_i
```
"""
function rydberg_h(atom_positions; C = 2π * 862690, Ω = nothing, ϕ = nothing, Δ = nothing)
    return rydberg_h(atom_positions, C, Ω, ϕ, Δ)
end

function rydberg_h(atom_positions, C, Ω, ϕ, Δ)
    positions = process_atom_positions(atom_positions)

    nsites = length(positions)
    rydberg_term = RydInteract(positions, C)

    Ω = div_by_two(Ω)
 
    if !isnothing(Ω) && !isnothing(ϕ)
        rabi_term = SumOfXPhase(nsites, Ω, ϕ)
    elseif !isnothing(Ω) && isnothing(ϕ)
        rabi_term = SumOfX(nsites, Ω)
    elseif isnothing(Ω) && !isnothing(ϕ)
        @warn "Rydberg Hamiltonian contains non-zero rabi phase ϕ with no rabi amplitude Ω."
        rabi_term = SumOfXPhase(nsites, 0, ϕ)
    else
        rabi_term = nothing
    end

    if !isnothing(Δ)
        detuning_term = SumOfN(nsites, Δ)
    else
        detuning_term = nothing
    end

    return RydbergHamiltonian(rydberg_term,rabi_term,detuning_term)
end

"""
    rydberg_h_3(atoms; [C=2π * 862690 * MHz*µm^6, 
        Ω_hf = nothing, ϕ_hf = nothing, Δ_hf = nothing, 
        Ω_r = nothing, ϕ_r = nothing, Δ_r = nothing])

Create a 3-level Rydberg Hamiltonian

```math
\\sum_{i<j} \\frac{C}{|x_i - x_j|^6} n^r_i n^r_j + 
\\sum_{i} \\left[\\frac{Ω^{\\mathrm{hf}}}{2} (e^{iϕ^\\mathrm{hf}}|0⟩⟨1| + e^{-iϕ^\\mathrm{hf}}|1⟩⟨0|) - Δ^{\\mathrm{hf}} n^{1}_i + 
\\frac{Ω^{\\mathrm{r}}}{2} (e^{iϕ^\\mathrm{r}}|1⟩⟨r| + e^{-iϕ^\\mathrm{r}}|r⟩⟨1|) - (Δ^{\\mathrm{hf}} + Δ^{\\mathrm{r}}) n^{\\mathrm{r}}_i \\right]
```

shorthand for

```julia
RydInteract(C, atoms; nlevel = 3) + 
    SumOfXPhase_01(length(atoms), Ω_hf/2, ϕ_hf) - SumOfN(length(atoms), Δ_hf) +
    SumOfXPhase_1r(length(atoms), Ω_r/2, ϕ_r) - SumOfN(length(atoms), Δ_r + Δ_hf)
```
"""
function rydberg_h_3(atom_positions; 
        C = 2π * 862690, Ω_hf = nothing, ϕ_hf = nothing, Δ_hf = nothing, 
        Ω_r = nothing, ϕ_r = nothing, Δ_r = nothing)
    return rydberg_h_3(atom_positions, C, Ω_hf, ϕ_hf, Δ_hf, Ω_r, ϕ_r, Δ_r)
end

function rydberg_h_3(atom_positions, C, Ω_hf, ϕ_hf, Δ_hf, Ω_r, ϕ_r, Δ_r)
    positions = process_atom_positions(atom_positions)

    nsites = length(positions)
    rydberg_term = RydInteract(positions, C; nlevel = 3)

    Ω_hf = div_by_two(Ω_hf)
    if !isnothing(Ω_hf) && !isnothing(ϕ_hf)
        rabi_term_hf = SumOfXPhase_01(nsites, Ω_hf, ϕ_hf)
    elseif !isnothing(Ω_hf) && isnothing(ϕ_hf)
        rabi_term_hf = SumOfX_01(nsites, Ω_hf)
    elseif isnothing(Ω_hf) && !isnothing(ϕ_hf)
        @warn "Rydberg Hamiltonian contains non-zero rabi phase ϕ_hf with no rabi amplitude Ω_hf."
        rabi_term_hf = SumOfXPhase_01(nsites, 0, ϕ_hf)
    else
        rabi_term_hf = nothing
    end
    
    Ω_r = div_by_two(Ω_r)
    if !isnothing(Ω_r) && !isnothing(ϕ_r)
        rabi_term_r = SumOfXPhase_1r(nsites, Ω_r, ϕ_r)
    elseif !isnothing(Ω_r) && isnothing(ϕ_r)
        rabi_term_r = SumOfX_1r(nsites, Ω_r)
    elseif isnothing(Ω_r) && !isnothing(ϕ_r)
        @warn "Rydberg Hamiltonian contains non-zero rabi phase ϕ_r with no rabi amplitude Ω_r."
        rabi_term_r = SumOfXPhase_1r(nsites, 0, ϕ_r)
    else
        rabi_term_r = nothing
    end

    detuning_term_hf = !isnothing(Δ_hf) ? SumOfN_1(nsites, Δ_hf) : nothing
    detuning_term_r = if !isnothing(Δ_r)
        if !isnothing(Δ_hf) 
            SumOfN_r(nsites, add_params(Δ_hf, Δ_r))
        else
            SumOfN_r(nsites, Δ_r)
        end
    elseif !isnothing(Δ_hf)
        SumOfN_r(nsites, Δ_hf)
    else
        nothing
    end

    rh3 = RydbergHamiltonian3(rydberg_term, rabi_term_hf, detuning_term_hf, rabi_term_r, detuning_term_r)
    return rh3
end

function add_params(a, b)
    if a isa Vector && b isa Vector
        return add_param.(a, b)
    elseif a isa Vector && !(b isa Vector)
        return add_param.(a, fill(b, length(a)))
    elseif !(a isa Vector) && b isa Vector
        return add_param.(fill(a, length(b)), b)
    else
        return add_param(a, b)
    end
end

function add_param(a, b)
    if is_const_param(a) && is_const_param(b)
        return a + b
    elseif is_time_function(a) && is_const_param(b)
        return x -> a(x) + b
    elseif is_const_param(a) && is_time_function(b)
        return x -> a + b(x)
    else
        return x -> a(x) + b(x)
    end
end

function div_by_two(Ω)
    isnothing(Ω) && return
    if is_const_param(Ω)
        return Ω ./ 2
    end

    return if Ω isa Vector
        map(Ω) do Ω_i
            return DivByTwo(Ω_i)
        end
    else
        DivByTwo(Ω)
    end
end



function mult_by_two(Ω)
    isnothing(Ω) && return
    if is_const_param(Ω)
        return Ω .* 2
    end

    return if Ω isa Vector
        map(Ω) do Ω_i
            return Ω_i.f
        end
    else
        Ω.f
    end

end

"""
    get_rydberg_params(h)

Returns a named tuple containing the fields `atoms`, `ϕ`, `Ω`, and `Δ` for the RydbergHamiltonian, `h`.

See also [`rydberg_h`](@ref)

# Example

```julia
    (atoms,ϕ,Ω,Δ) = get_rydberg_params(h)
````

"""
function get_rydberg_params(h::RydbergHamiltonian)
    # extracts parameters from RydbergHamiltonian
    ϕ = nothing
    Ω = nothing
    Δ = nothing

    if h.rabi_term isa SumOfX
        Ω = mult_by_two(h.rabi_term.Ω)
    elseif h.rabi_term isa SumOfXPhase
        Ω = mult_by_two(h.rabi_term.Ω)
        ϕ = h.rabi_term.ϕ
    end

    if h.detuning_term isa SumOfN
        Δ = h.detuning_term.Δ
    end

    return (atoms=h.rydberg_term.atoms,ϕ=ϕ,Ω=Ω,Δ=Δ)
end

attime(t::Real) = h -> attime(h, t)

function attime(h::AbstractBlock, t::Real)
    blks = map(subblocks(h)) do blk
        return attime(blk, t)
    end
    return chsubblocks(h, blks)
end


# Yao Blocks cannot take time-dependent function

"""
    attime(h, t)
    attime(t)

Return the hamiltonian at time `t`.

# Example

```julia
julia> h = rydberg_h(atoms; Ω=sin)
nqudits: 4
+
├─ ∑ 5.42e6/|x_i-x_j|^6 n_i n_j
└─ Ω(t) ⋅ ∑ σ^x_i

julia> h |> attime(0.1)
nqudits: 4
+
├─ ∑ 5.42e6/|x_i-x_j|^6 n_i n_j
└─ 0.0499 ⋅ ∑ σ^x_i
```
"""
attime(h::PrimitiveBlock, ::Real) = h
function attime(h::SumOfXTypes, t::Real)
    is_const_param(h.Ω) && return h
    T = typeof(h)
    if h.Ω isa Vector
        T(h.nsites, map(x -> x(t), h.Ω))
    else
        T(h.nsites, h.Ω(t))
    end
end

function attime(h::SumOfXPhaseTypes, t::Real)
    if is_const_param(h.Ω)
        Ω = h.Ω
    elseif h.Ω isa Vector
        Ω = map(x -> x(t), h.Ω)
    else
        Ω = h.Ω(t)
    end

    if is_const_param(h.ϕ)
        ϕ = h.ϕ
    elseif h.ϕ isa Vector
        ϕ = map(x -> x(t), h.ϕ)
    else
        ϕ = h.ϕ(t)
    end

    T = typeof(h)
    return T(h.nsites, Ω, ϕ)
end

function attime(h::SumOfZAndNTypes, t::Real)
    if is_const_param(h.Δ)
        Δ = h.Δ
    elseif h.Δ isa Vector
        Δ = map(x -> x(t), h.Δ)
    else
        Δ = h.Δ(t)
    end
    return typeof(h)(h.nsites, Δ)
end

attime(h::RydbergHamiltonian, t::Real) = attime(add_terms(h),t)
attime(h::RydbergHamiltonian3, t::Real) = attime(add_terms(h),t)

distance(a, b) = sqrt(mapreduce(x -> x^2, +, a .- b))

function YaoAPI.mat(::Type{T}, h::AbstractBlock, space::FullSpace) where {T}
    return YaoAPI.mat(T, h)
end

YaoAPI.mat(::Type{T}, h::XPhase{P}) where {T, P} = PermMatrix([2, 1], T[exp(h.ϕ * im), exp(-h.ϕ * im)])
YaoAPI.mat(::Type{T}, h::XPhase_01{P}) where {T, P} = PermMatrix([2, 1, 3], T[exp(h.ϕ * im), exp(-h.ϕ * im), 0])
YaoAPI.mat(::Type{T}, h::XPhase_1r{P}) where {T, P} = PermMatrix([1, 3, 2], T[0, exp(h.ϕ * im), exp(-h.ϕ * im)])

YaoAPI.mat(::Type{T}, h::PuPhase{P}) where {T, P} = sparse([1], [2], T[exp(h.ϕ * im)], 2, 2)
YaoAPI.mat(::Type{T}, h::PuPhase_1r{P}) where {T, P} = sparse([2], [3], T[exp(h.ϕ * im)], 3, 3)
YaoAPI.mat(::Type{T}, h::PuPhase_01{P}) where {T, P} = sparse([1], [2], T[exp(h.ϕ * im)], 3, 3)

YaoAPI.mat(::Type{T}, h::PdPhase{P}) where {T, P} = sparse([2], [1], T[exp(-h.ϕ * im)], 2, 2)
YaoAPI.mat(::Type{T}, h::PdPhase_01{P}) where {T, P} = sparse([2], [1], T[exp(-h.ϕ * im)], 3, 3)
YaoAPI.mat(::Type{T}, h::PdPhase_1r{P}) where {T, P} = sparse([3], [2], T[exp(-h.ϕ * im)], 3, 3)

YaoAPI.mat(::Type{T}, ::OpX_01) where T = PermMatrix([2, 1, 3], T[1, 1, 0])
YaoAPI.mat(::Type{T}, ::OpX_1r) where T = PermMatrix([1, 3, 2], T[0, 1, 1])

YaoAPI.mat(::Type{T}, ::OpZ_01) where T = Diagonal(T[1, -1, 0])
YaoAPI.mat(::Type{T}, ::OpZ_1r) where T = Diagonal(T[0, 1, -1])

YaoAPI.mat(::Type{T}, ::OpN_1) where T = sparse([2], [2], T[1], 3, 3)
YaoAPI.mat(::Type{T}, ::OpN_r) where T = sparse([3], [3], T[1], 3, 3)

YaoAPI.mat(::Type{T}, ::OpPu_01) where T = sparse([1], [2], T[1], 3, 3)
YaoAPI.mat(::Type{T}, ::OpPu_1r) where T = sparse([2], [3], T[1], 3, 3)

YaoAPI.mat(::Type{T}, ::OpPd_01) where T = sparse([2], [1], T[1], 3, 3)
YaoAPI.mat(::Type{T}, ::OpPd_1r) where T = sparse([3], [2], T[1], 3, 3)

function YaoAPI.mat(::Type{T}, h::AbstractTerm{D}, space::FullSpace = fullspace) where {T, D}
    blocks = YaoBlocks.Optimise.simplify(h; rules = [YaoBlocks.Optimise.to_basictypes])
    return YaoAPI.mat(T, blocks)
end

function YaoAPI.mat(::Type{T}, h::AbstractTerm{D}, space::Subspace) where {T, D}
    blocks = YaoBlocks.Optimise.simplify(h; rules = [YaoBlocks.Optimise.to_basictypes])
    return YaoAPI.mat(T, blocks, space)
end

# fallback
YaoBlocks.mat(::Type{T}, x::AbstractBlock, s::Subspace) where {T} = _toregular_matrix(mat(T, x))[s, s]
_toregular_matrix(x::AbstractMatrix) = x
_toregular_matrix(x::Union{PermMatrix,IMatrix}) = SparseMatrixCSC(x)
YaoBlocks.mat(x::AbstractBlock, s::Subspace) = mat(promote_type(ComplexF64, YaoBlocks.parameters_eltype(x)), x, s)

YaoBlocks.mat(::Type{T}, d::TrivialGate{N}, s::Subspace) where {T,N} = IMatrix{T}(length(s))
YaoBlocks.mat(::Type{T}, pb::PutBlock{N,C}, s::Subspace) where {T,N,C} =
    _cunmat(s.subspace_v, s.map, (), (), mat(T, pb.content), pb.locs)
YaoBlocks.mat(::Type{T}, c::Subroutine{D,<:AbstractBlock}, s::Subspace) where {D,T} =
    mat(T, PutBlock(c.n, c.content, c.locs), s)
YaoBlocks.mat(::Type{T}, x::Scale, s::Subspace) where {T} = YaoBlocks.factor(x) * mat(T, content(x), s)
YaoBlocks.mat(::Type{T}, blk::Daggered, s::Subspace) where {T} = adjoint(mat(T, content(blk), s))
YaoBlocks.mat(::Type{T}, c::ControlBlock{N,BT,C}, s::Subspace) where {T,N,BT,C} =
    _cunmat(s.subspace_v, s.map, c.ctrl_locs, c.ctrl_config, mat(T, c.content), c.locs)
YaoBlocks.mat(::Type{T}, x::Add{N}, s::Subspace) where {N,T} = mapreduce(x -> mat(T, x, s), +, x.list)
function YaoBlocks.mat(::Type{T}, c::ChainBlock, s::Subspace) where {T}
    # @warn "ChainBlock is applying subspace on its subblocks, which may be inconsistent with multiply and then take subspace."
    return prod(x -> mat(T, x, s), Iterators.reverse(c.blocks))
end
function YaoBlocks.mat(::Type{T}, te::TimeEvolution{N}, s::Subspace) where {T,N}
    @warn "TimeEvolution block is applying subspace on its subblock, which may be inconsistent with time evolve and then take subspace."
    return exp(-im * T(te.dt) * Matrix(mat(T, te.H, s)))
end
# NOTE: CachedBlock is not yet implemented.

function _cunmat(
    subspace_v::AbstractVector{TI},
    map,
    cbits::NTuple{C,Int},
    cvals::NTuple{C,Int},
    U0::AbstractMatrix{T},
    locs::NTuple{M,Int},
) where {TI,T,C,M}
    U = staticize(all(diff(collect(locs)) .> 0) ? U0 : reorder(U0, collect(locs) |> sortperm))
    # ctest = YaoBlocks.controller(TI, cbits, cvals)
    # NOTE: remove the following lines after the update of BitBasis!
    do_mask = bmask(TI, cbits...)
    target =
        length(cvals) == 0 ? zero(TI) :
        mapreduce(xy -> (xy[2] == 1 ? one(TI) << TI(xy[1] - 1) : zero(TI)), |, zip(cbits, cvals))
    ctest = b -> ismatch(b, do_mask, target)
    return _main_loop(subspace_v, map, U, ctest, locs)
end

function _main_loop(subspace_v, map, U::AbstractMatrix{T}, ctest, locs) where {T}
    N = length(subspace_v)
    MM = size(U, 1)
    colptr = Vector{Int}(undef, N + 1)
    colptr[1] = 1
    locs_zeroclear_mask = ~bmask(locs...)
    NNZ_MAX = max(1, maximum([count(!iszero, view(U, :, j)) for j in 1:size(U, 2)])) * N
    rowval = Vector{Int}(undef, NNZ_MAX)
    nzval = Vector{T}(undef, NNZ_MAX)
    nel = 0

    @inbounds for j in 1:N
        J = subspace_v[j]
        jindex = readbit(J, locs...)
        if ctest(J)
            I0 = J & locs_zeroclear_mask
            nj = 0
            for iindex in 0:MM-1
                mij = U[iindex+1, jindex+1]
                iszero(mij) && continue
                I = setlocbits(I0, locs, iindex)
                i = get(map, I, -1)
                if i > 0
                    nel += 1
                    rowval[nel] = i
                    nzval[nel] = mij
                    nj += 1
                end
            end
            colptr[j+1] = colptr[j] + nj
        else
            nel += 1
            colptr[j+1] = colptr[j] + 1
            rowval[nel] = j
            nzval[nel] = one(T)
        end
    end
    return SparseMatrixCSC(N, N, colptr, rowval[1:nel], nzval[1:nel])
end

@inline @generated function setlocbits(I0, locs::NTuple{N}, iindex) where {N}
    quote
        @nexprs $N i -> I0 = I0 | (readbit(iindex, i) << (locs[i] - 1))
        return I0
    end
end

using Test
using BloqadeExpr
using YaoAPI
using LinearAlgebra
using Random
using SparseArrays
using SparseMatricesCSR
using LuxurySparse
using BloqadeExpr: Hamiltonian

atoms = [(1, 1), (1, 2), (1, 3), (1, 4), (1, 5)]
h = rydberg_h(atoms; Ω = 1.0, Δ = sin)

hlist = Hamiltonian(Float64, h)
@test length(hlist.fs) == 2
@test hlist.fs[end] === one

H = sum(zip(hlist.fs, hlist.ts)) do (f, t)
    return f(0.1) * t
end

C = zeros(ComplexF64, 1 << 5)
B = rand(ComplexF64, 1 << 5)
ot = zeros(ComplexF64, 1 << 5)
mul!(ot, hlist(0.1), B)
@test  ot ≈ H * B

# ThreadedMatrix unit tests
  # ThreadedMatrix with SparseMatrixCSC
  # Threaded Matrix with CSR and Diagonal matrix inside

@testset "ThreadedMatrix for Parallel Emulation mul" begin

    # these values are not mutated and can be re-used throughout the unit tests
    B = rand(ComplexF64, 10)
    α = 0.5 + 1.0im
    β = 2.1 + 3.3im

    @testset "CSR-format Matrix (mul)" begin

        C_original = rand(ComplexF64, 10)
        C_copy = deepcopy(C_original)

        A = sprand(ComplexF64, 10, 10, 0.1)
        A_threaded = A |> transpose |> SparseMatrixCSR |>  BloqadeExpr.ThreadedMatrix

        SparseArrays.mul!(C_original, transpose(A), B, α, β) # C -> A B α + C β 
        BloqadeExpr.mul!(C_copy, A_threaded, B, α, β)

        @test C_original == C_copy
    end

    @testset "Diagonal Matrix (mul)" begin

        C_original = rand(ComplexF64, 10)
        C_copy = deepcopy(C_original)

        A = Diagonal(rand(ComplexF64, 10))
        A_threaded = A |> BloqadeExpr.ThreadedMatrix

        SparseArrays.mul!(C_original, A, B, α, β) # C -> A B α + C β 
        BloqadeExpr.mul!(C_copy, A_threaded, B, α, β)

        @test C_original == C_copy
    end

    @testset "Permutation Matrix (mul)" begin

        C_original = rand(ComplexF64, 10)
        C_copy = deepcopy(C_original)

        A = PermMatrix(shuffle(1:10), rand(ComplexF64, 10))
        A_threaded = A |> BloqadeExpr.ThreadedMatrix
       
        mul!(C_original, A, B, α, β)
        BloqadeExpr.mul!(C_copy, A_threaded, B, α, β)

        @test C_original == C_copy
    end

end

# NOTE: these high level expression
# will be converted to lower level Hamiltonian object
# before simulation no need to aggressively specialize on them
# the following operators are mainly used to interface
# with Yao

"""
    XPhase{T} <: PrimitiveBlock{2}

XPhase operator for 2-level Rydberg system.

```math
e^{ϕ ⋅ i} |0⟩⟨1| + e^{-ϕ ⋅ i} |1⟩⟨0|
```
"""
struct XPhase{T} <: PrimitiveBlock{2}
    ϕ::T
end

"""
    XPhase_01{T} <: PrimitiveBlock{3}

XPhase operator act on |0⟩ and |1⟩ for 3-level Rydberg system.

```math
e^{ϕ ⋅ i} |0⟩⟨1| + e^{-ϕ ⋅ i} |1⟩⟨0| = 
\\begin{pmatrix}
0 & e^{ϕ ⋅ im} & 0 \\\\
e^{-ϕ ⋅ im} & 0 & 0 \\\\
0 & 0 & 0
\\end{pmatrix}
```
"""
struct XPhase_01{T} <: PrimitiveBlock{3}
    ϕ::T
end

"""
    XPhase_1r{T} <: PrimitiveBlock{3}

XPhase operator act on |1⟩ and |r⟩ for 3-level Rydberg system.

```math
e^{ϕ ⋅ i} |1⟩⟨r| + e^{-ϕ ⋅ i} |r⟩⟨1| = 
\\begin{pmatrix}
0 & 0 & 0 \\\\
0 & 0 & e^{ϕ ⋅ im} \\\\
0 & e^{-ϕ ⋅ im} & 0
\\end{pmatrix}
```
"""
struct XPhase_1r{T} <: PrimitiveBlock{3}
    ϕ::T
end

struct PuPhase{T} <: PrimitiveBlock{2}
    ϕ::T
end
struct PuPhase_01{T} <: PrimitiveBlock{3}
    ϕ::T
end
struct PuPhase_1r{T} <: PrimitiveBlock{3}
    ϕ::T
end

struct PdPhase{T} <: PrimitiveBlock{2}
    ϕ::T
end
struct PdPhase_01{T} <: PrimitiveBlock{3}
    ϕ::T
end
struct PdPhase_1r{T} <: PrimitiveBlock{3}
    ϕ::T
end

struct OpX_01 <: YaoBlocks.ConstantGate{1, 3} end
struct OpX_1r <: YaoBlocks.ConstantGate{1, 3} end
struct OpZ_01 <: YaoBlocks.ConstantGate{1, 3} end
struct OpZ_1r <: YaoBlocks.ConstantGate{1, 3} end
struct OpN_1 <: YaoBlocks.ConstantGate{1, 3} end
struct OpN_r <: YaoBlocks.ConstantGate{1, 3} end
struct OpPu_01 <: YaoBlocks.ConstantGate{1, 3} end
struct OpPu_1r <: YaoBlocks.ConstantGate{1, 3} end
struct OpPd_01 <: YaoBlocks.ConstantGate{1, 3} end
struct OpPd_1r <: YaoBlocks.ConstantGate{1, 3} end

const X_01 = OpX_01()
const X_1r = OpX_1r()
const Z_01 = OpZ_01()
const Z_1r = OpZ_1r()
const N_1 = OpN_1()
const N_r = OpN_r()
const Pu_01 = OpPu_01()
const Pu_1r = OpPu_1r()
const Pd_01 = OpPd_01()
const Pd_1r = OpPd_1r()


# ==================== Docstring for 3-level constant gates ====================

"""
    X_01
    OpX_01 <: YaoBlocks.ConstantGate{1, 3}

Pauli X operator act on |0⟩ and |1⟩ for 3-level Rydberg system.

Matrix expression:

```math
\\sigma^{x,\\mathrm{hf}} = 
\\begin{pmatrix}
0 & 1 & 0 \\\\
1 & 0 & 0 \\\\
0 & 0 & 0
\\end{pmatrix}
```
"""
X_01, OpX_01

"""
    X_1r
    OpX_1r <: YaoBlocks.ConstantGate{1, 3}

Pauli X operator act on |1⟩ and |r⟩ for 3-level Rydberg system.

Matrix expression:

```math
\\sigma^{x,\\mathrm{r}} = 
\\begin{pmatrix}
0 & 0 & 0 \\\\
0 & 0 & 1 \\\\
0 & 1 & 0
\\end{pmatrix}
```
"""
X_1r, OpX_1r

"""
    Z_01
    OpZ_01 <: YaoBlocks.ConstantGate{1, 3}

Pauli Z operator act on |0⟩ and |1⟩ for 3-level Rydberg system.

Matrix expression:

```math
\\sigma^{z,\\mathrm{hf}} = 
\\begin{pmatrix}
1 & 0 & 0 \\\\
0 & -1 & 0 \\\\
0 & 0 & 0
\\end{pmatrix}
```
"""
Z_01, OpZ_01

"""
    Z_1r
    OpZ_1r <: YaoBlocks.ConstantGate{1, 3}

Pauli Z operator act on |1⟩ and |r⟩ for 3-level Rydberg system.

Matrix expression:

```math
\\sigma^{z,\\mathrm{r}} = 
\\begin{pmatrix}
0 & 0 & 0 \\\\
0 & 1 & 0 \\\\
0 & 0 & -1
\\end{pmatrix}
```
"""
Z_1r, OpZ_1r

"""
    N_1
    OpN_1 <: YaoBlocks.ConstantGate{1, 3}

Projection operator onto |1⟩ for 3-level Rydberg system.

Matrix expression:

```math
n^1 = |1⟩⟨1| = 
\\begin{pmatrix}
0 & 0 & 0 \\\\
0 & 1 & 0 \\\\
0 & 0 & 0
\\end{pmatrix}
```
"""
N_1, OpN_1

"""
    N_r
    OpN_r <: YaoBlocks.ConstantGate{1, 3}

Projection operator onto |r⟩ for 3-level Rydberg system.

Matrix expression:
    
```math
n^{\\mathrm{r}} = |r⟩⟨r| = 
\\begin{pmatrix}
0 & 0 & 0 \\\\
0 & 0 & 0 \\\\
0 & 0 & 1
\\end{pmatrix}
```
"""
N_r, OpN_r

"""
    Pu_01
    OpPu_01 <: YaoBlocks.ConstantGate{1, 3}

Matrix expression:

```math
\\mathrm{Pu}^{\\mathrm{hf}} = 
\\begin{pmatrix}
0 & 1 & 0 \\\\
0 & 0 & 0 \\\\
0 & 0 & 0
\\end{pmatrix}
```
"""
Pu_01, OpPu_01


"""
    Pu_1r
    OpPu_1r <: YaoBlocks.ConstantGate{1, 3}

Matrix expression:

```math
\\mathrm{Pu}^{\\mathrm{r}} = 
\\begin{pmatrix}
0 & 0 & 0 \\\\
0 & 0 & 1 \\\\
0 & 0 & 0
\\end{pmatrix}
```
"""
Pu_1r, OpPu_1r

"""
    Pd_01
    OpPd_01 <: YaoBlocks.ConstantGate{1, 3}

Matrix expression:

```math
\\mathrm{Pd}^{\\mathrm{hf}} = 
\\begin{pmatrix}
0 & 0 & 0 \\\\
1 & 0 & 0 \\\\
0 & 0 & 0
\\end{pmatrix}
```
"""
Pd_01, OpPd_01

"""
    Pd_1r
    OpPd_1r <: YaoBlocks.ConstantGate{1, 3}

Matrix expression:

```math
\\mathrm{Pd}^{\\mathrm{r}} = 
\\begin{pmatrix}
0 & 0 & 0 \\\\
0 & 0 & 0 \\\\
0 & 1 & 0
\\end{pmatrix}
```
"""
Pd_1r, OpPd_1r

# ==================== Docstring for 3-level constant gates (end) ====================


"""
    AbstractTerm{D} <: PrimitiveBlock{D}

Abstract term for local hamiltonian terms on D-level system.
"""
abstract type AbstractTerm{D} <: PrimitiveBlock{D} end

YaoBlocks.unsafe_getindex(::Type{T}, x::AbstractTerm, i::Integer, j::Integer) where T = YaoBlocks.unsafe_getindex(T, YaoBlocks.Optimise.to_basictypes(x), i, j)
YaoBlocks.unsafe_getcol(::Type{T}, x::AbstractTerm, j::DitStr{2}) where T = YaoBlocks.unsafe_getcol(T, YaoBlocks.Optimise.to_basictypes(x), j)
YaoBlocks.ishermitian(::AbstractTerm) = true

"""
    struct RydInteract{D} <: AbstractTerm{D}
    RydInteract(;atoms, C=2π * 862690MHz⋅μm^6)

Type for Rydberg interactive term.

# Expression

```math
\\sum_{i, j} \\frac{C}{|x_i - x_j|^6} n_i n_j
```

# Keyword Arguments

- `atoms`: a list of atom positions, must be type `RydAtom`, default unit is `μm`.
- `C`: the interaction strength, default unit is `MHz⋅μm^6`. default value is `2π * 862690 * MHz*µm^6`.
"""
Base.@kwdef struct RydInteract{D} <: AbstractTerm{D}
    atoms::Union{Vector,BoundedLattice}
    C::Real = 2π * 862690

    function RydInteract{D}(atoms, C) where D
        return new{D}(atoms, default_unit(MHz * µm^6, C))
    end
end
RydInteract(atoms, C; nlevel = 2) = RydInteract{nlevel}(atoms, C)

"""
    struct SumOfX <: AbstractTerm{2}
    SumOfX(nsites, Ω)

Term for sum of X operators.

The following two expressions are equivalent

```jldoctest; setup=:(using BloqadeExpr, YaoBlocks)
julia> SumOfX(nsites=5)
∑ σ^x_i

julia> sum([X for _ in 1:5])
nqudits: 1
+
├─ X
├─ X
├─ X
├─ X
└─ X
```

# Expression

```math
\\sum_i Ω σ^x_i
```
"""
Base.@kwdef struct SumOfX <: AbstractTerm{2}
    nsites::Int
    Ω = 1

    function SumOfX(nsites::Int, Ω)
        assert_param(nsites, Ω, :Ω)
        Ω = default_unit(MHz, Ω)
        return new(nsites, Ω)
    end
end
SumOfX(n::Int) = SumOfX(n, 1)

"""
    struct SumOfX_01 <: AbstractTerm{3}
    SumOfX_01(nsites, Ω)

Term for sum of `X_01` operators.

# Expression

```math
\\sum_i Ω σ^{x,\\mathrm{hf}}_i
```
"""
Base.@kwdef struct SumOfX_01 <: AbstractTerm{3}
    nsites::Int
    Ω = 1

    function SumOfX_01(nsites::Int, Ω)
        assert_param(nsites, Ω, :Ω)
        Ω = default_unit(MHz, Ω)
        return new(nsites, Ω)
    end
end
SumOfX_01(n::Int) = SumOfX_01(n, 1)

"""
    struct SumOfX_1r <: AbstractTerm{3}
    SumOfX_1r(nsites, Ω)

Term for sum of `X_1r` operators.

# Expression

```math
\\sum_i Ω σ^{x,\\mathrm{r}}_i
```
"""
Base.@kwdef struct SumOfX_1r <: AbstractTerm{3}
    nsites::Int
    Ω = 1

    function SumOfX_1r(nsites::Int, Ω)
        assert_param(nsites, Ω, :Ω)
        Ω = default_unit(MHz, Ω)
        return new(nsites, Ω)
    end
end
SumOfX_1r(n::Int) = SumOfX_1r(n, 1)


"""
    struct SumOfXPhase <: AbstractTerm{2}
    SumOfXPhase(;nsites, Ω=1, ϕ)

Sum of `XPhase` operators.

The following two expressions are equivalent

```jldoctest; setup=:(using BloqadeExpr)
julia> SumOfXPhase(nsites=5, ϕ=0.1)
1.0 ⋅ ∑ e^{0.1 ⋅ im} |0⟩⟨1| + e^{-0.1 ⋅ im} |1⟩⟨0|

julia> sum([XPhase(0.1) for _ in 1:5])
nqudits: 1
+
├─ XPhase(0.1)
├─ XPhase(0.1)
├─ XPhase(0.1)
├─ XPhase(0.1)
└─ XPhase(0.1)
```

But may provide extra speed up.

# Expression

```math
\\sum_i Ω ⋅ (e^{ϕ ⋅ i} |0⟩⟨1| + e^{-ϕ ⋅ i} |1⟩⟨0|)
```
"""
Base.@kwdef struct SumOfXPhase <: AbstractTerm{2}
    nsites::Int
    Ω = 1
    ϕ::Any

    function SumOfXPhase(nsites, Ω, ϕ)
        assert_param(nsites, Ω, :Ω)
        assert_param(nsites, ϕ, :ϕ)

        Ω = default_unit(MHz, Ω)
        ϕ = default_unit(NoUnits, ϕ)
        return new(nsites, Ω, ϕ)
    end
end

"""
    struct SumOfXPhase_01 <: AbstractTerm{3}
    SumOfXPhase_01(nsites, Ω, ϕ)

Term for sum of `XPhase_01` operators.

# Expression

```math
\\sum_i Ω ⋅ (e^{ϕ ⋅ i} |0⟩⟨1| + e^{-ϕ ⋅ i} |1⟩⟨0|)
```
"""
Base.@kwdef struct SumOfXPhase_01 <: AbstractTerm{3}
    nsites::Int
    Ω = 1
    ϕ::Any

    function SumOfXPhase_01(nsites, Ω, ϕ)
        assert_param(nsites, Ω, :Ω)
        assert_param(nsites, ϕ, :ϕ)

        Ω = default_unit(MHz, Ω)
        ϕ = default_unit(NoUnits, ϕ)
        return new(nsites, Ω, ϕ)
    end
end

"""
    struct SumOfXPhase_1r <: AbstractTerm{3}
    SumOfXPhase_1r(nsites, Ω, ϕ)

Term for sum of `XPhase_1r` operators.

# Expression

```math
\\sum_i Ω ⋅ (e^{ϕ ⋅ i} |1⟩⟨r| + e^{-ϕ ⋅ i} |r⟩⟨1|)
```
"""
Base.@kwdef struct SumOfXPhase_1r <: AbstractTerm{3}
    nsites::Int
    Ω = 1
    ϕ::Any

    function SumOfXPhase_1r(nsites, Ω, ϕ)
        assert_param(nsites, Ω, :Ω)
        assert_param(nsites, ϕ, :ϕ)

        Ω = default_unit(MHz, Ω)
        ϕ = default_unit(NoUnits, ϕ)
        return new(nsites, Ω, ϕ)
    end
end


"""
    struct SumOfN <: AbstractTerm{2}
    SumOfN(;nsites[, Δ=1])

Sum of N operators. 

The following two expression are equivalent

```jldoctest; setup=:(using BloqadeExpr)
julia> SumOfN(nsites=5)
∑ n_i

julia> sum([Op.n for _ in 1:5])
nqudits: 1
+
├─ P1
├─ P1
├─ P1
├─ P1
└─ P1
```

But may provide extra speed up.

# Expression

```math
\\sum_i Δ ⋅ n_i
```
"""
Base.@kwdef struct SumOfN <: AbstractTerm{2}
    nsites::Int
    Δ = 1

    function SumOfN(nsites, Δ)
        assert_param(nsites, Δ, :Δ)
        return new(nsites, default_unit(MHz, Δ))
    end
end
SumOfN(n::Int) = SumOfN(n, 1)

"""
    struct SumOfN_r <: AbstractTerm{3}
    SumOfN_1(;nsites[, Δ=1])

Sum of N_r operators. 

# Expression

```math
\\sum_i Δ ⋅ n^r_i
```
"""
Base.@kwdef struct SumOfN_r <: AbstractTerm{3}
    nsites::Int
    Δ = 1

    function SumOfN_r(nsites, Δ)
        assert_param(nsites, Δ, :Δ)
        return new(nsites, default_unit(MHz, Δ))
    end
end
SumOfN_r(n::Int) = SumOfN_r(n, 1)

"""
    struct SumOfN_1 <: AbstractTerm{3}
    SumOfN_1(;nsites[, Δ=1])

Sum of N_1 operators. 

# Expression

```math
\\sum_i Δ ⋅ n^r_i
```
"""
Base.@kwdef struct SumOfN_1 <: AbstractTerm{3}
    nsites::Int
    Δ = 1

    function SumOfN_1(nsites, Δ)
        assert_param(nsites, Δ, :Δ)
        return new(nsites, default_unit(MHz, Δ))
    end
end
SumOfN_1(n::Int) = SumOfN_1(n, 1)

"""
    struct SumOfZ <: AbstractTerm{2}
    SumOfZ(;nsites, Δ=1)

Sum of Pauli Z operators.

The following two expression are equivalent

```jldoctest; setup=:(using BloqadeExpr, YaoBlocks)
julia> SumOfZ(nsites=5)
∑ σ^z_i

julia> sum([Z for _ in 1:5])
nqudits: 1
+
├─ Z
├─ Z
├─ Z
├─ Z
└─ Z
```

# Expression

```math
\\sum_i Δ ⋅ σ^z_i
```
"""
Base.@kwdef struct SumOfZ <: AbstractTerm{2}
    nsites::Int
    Δ = 1

    function SumOfZ(nsites, Δ)
        assert_param(nsites, Δ, :Δ)
        return new(nsites, default_unit(MHz, Δ))
    end
end
SumOfZ(n::Int) = SumOfZ(n, 1)

"""
    struct SumOfZ_01 <: AbstractTerm{2}
    SumOfZ_01(;nsites, Δ=1)

Sum of Pauli Z_01 operators.

# Expression

```math
\\sum_i Δ ⋅ σ^{z,\\mathrm{hf}}_i
```
"""
Base.@kwdef struct SumOfZ_01 <: AbstractTerm{3}
    nsites::Int
    Δ = 1

    function SumOfZ_01(nsites, Δ)
        assert_param(nsites, Δ, :Δ)
        return new(nsites, default_unit(MHz, Δ))
    end
end
SumOfZ_01(n::Int) = SumOfZ_01(n, 1)

"""
    struct SumOfZ_1r <: AbstractTerm{2}
    SumOfZ_1r(;nsites, Δ=1)

Sum of Pauli Z_1r operators.

# Expression

```math
\\sum_i Δ ⋅ σ^{z,\\mathrm{r}}_i
```
"""
Base.@kwdef struct SumOfZ_1r <: AbstractTerm{3}
    nsites::Int
    Δ = 1

    function SumOfZ_1r(nsites, Δ)
        assert_param(nsites, Δ, :Δ)
        return new(nsites, default_unit(MHz, Δ))
    end
end
SumOfZ_1r(n::Int) = SumOfZ_1r(n, 1)


struct DivByTwo{F}
    f::F
    function DivByTwo(f)
        assert_has_time_method(f,:f)
        return new{typeof(f)}(f)
    end
end

@inline (Func::DivByTwo)(t::Real) = Func.f(t)/2


const RabiTypes = Union{Nothing,SumOfX,SumOfXPhase}
const DetuningTypes = Union{Nothing,SumOfN}

const HyperfineRabiTypes = Union{Nothing,SumOfX_01,SumOfXPhase_01}
const HyperfineDetuningTypes = Union{Nothing,SumOfN_1}
const RydbergRabiTypes = Union{Nothing,SumOfX_1r,SumOfXPhase_1r}
const RydbergDetuningTypes = Union{Nothing,SumOfN_r}

const SumOfXPhaseTypes = Union{SumOfXPhase, SumOfXPhase_01, SumOfXPhase_1r}
const SumOfZAndNTypes = Union{SumOfZ, SumOfZ_01, SumOfZ_1r, SumOfN, SumOfN_1, SumOfN_r}
const SumOfXTypes = Union{SumOfX, SumOfX_01, SumOfX_1r}
const ThreeLevelRydbergConstGates = Union{OpX_01, OpX_1r, OpZ_01, OpZ_1r, OpN_1, OpN_r, OpPu_01, OpPu_1r, OpPd_01, OpPd_1r}


struct RydbergHamiltonian <: AbstractTerm{2}
    rydberg_term::RydInteract{2}
    rabi_term::RabiTypes
    detuning_term::DetuningTypes
end

struct RydbergHamiltonian3 <: AbstractTerm{3}
    rydberg_term::RydInteract{3}
    rabi_term_hf::HyperfineRabiTypes
    detuning_term_hf::HyperfineDetuningTypes
    rabi_term_r::RydbergRabiTypes
    detuning_term_r::RydbergDetuningTypes
end

function add_terms(h::RydbergHamiltonian)
    terms = h.rydberg_term

    if typeof(h.rabi_term) <: Union{SumOfX,SumOfXPhase}
        terms += h.rabi_term
    end
    
    if h.detuning_term isa SumOfN
        terms -= h.detuning_term
    end
    
    return YaoBlocks.Optimise.simplify(terms)
end

function add_terms(h::RydbergHamiltonian3)
    terms = h.rydberg_term

    if typeof(h.rabi_term_hf) <: Union{SumOfX_01,SumOfXPhase_01}
        terms += h.rabi_term_hf
    end
    if typeof(h.rabi_term_r) <: Union{SumOfX_1r,SumOfXPhase_1r}
        terms += h.rabi_term_r
    end
    if h.detuning_term_hf isa SumOfN_1
        terms -= h.detuning_term_hf
    end
    if h.detuning_term_r isa SumOfN_r
        terms -= h.detuning_term_r
    end
    
    return YaoBlocks.Optimise.simplify(terms)
end

function YaoBlocks.unsafe_getindex(::Type{T}, h::RydbergHamiltonian, i::Integer, j::Integer) where T
    return YaoBlocks.unsafe_getindex(T, YaoBlocks.Optimise.to_basictypes(h), i, j)
end

function YaoBlocks.unsafe_getcol(::Type{T}, h::RydbergHamiltonian, j::DitStr{2}) where T
    YaoBlocks.unsafe_getcol(T, YaoBlocks.Optimise.to_basictypes(h), j)
end


YaoAPI.nqudits(::XPhase) = 1
YaoAPI.nqudits(::XPhase_01) = 1
YaoAPI.nqudits(::XPhase_1r) = 1
YaoAPI.nqudits(::PdPhase) = 1
YaoAPI.nqudits(::PdPhase_01) = 1
YaoAPI.nqudits(::PdPhase_1r) = 1
YaoAPI.nqudits(::PuPhase) = 1
YaoAPI.nqudits(::PuPhase_01) = 1
YaoAPI.nqudits(::PuPhase_1r) = 1
YaoAPI.nqudits(h::RydInteract) = length(h.atoms)
YaoAPI.nqudits(h::SumOfXTypes) = h.nsites
YaoAPI.nqudits(h::SumOfXPhaseTypes) = h.nsites
YaoAPI.nqudits(h::SumOfZAndNTypes) = h.nsites
YaoAPI.nqudits(::ThreeLevelRydbergConstGates) = 1
@inline YaoAPI.nqudits(h::Union{RydbergHamiltonian, RydbergHamiltonian3}) = nqudits(h.rydberg_term)

# checks of objects have the same base object f.
function Base.:(==)(lhs::DivByTwo{F1},rhs::DivByTwo{F2}) where {F1,F2} 
    return F1 == F2 && lhs.f == rhs.f
end

function Base.:(==)(lhs::RydInteract{D1}, rhs::RydInteract{D2}) where {D1, D2}
    return lhs.C == rhs.C && lhs.atoms == rhs.atoms && D1 == D2
end

function Base.:(==)(lhs::SumOfXTypes, rhs::SumOfXTypes)
    return lhs.nsites == rhs.nsites && lhs.Ω == rhs.Ω && typeof(lhs) == typeof(rhs)
end

function Base.:(==)(lhs::SumOfZAndNTypes, rhs::SumOfZAndNTypes)
    return lhs.nsites == rhs.nsites && lhs.Δ == rhs.Δ && typeof(lhs) == typeof(rhs)
end

function Base.:(==)(lhs::SumOfXPhaseTypes, rhs::SumOfXPhaseTypes)
    return lhs.nsites == rhs.nsites && lhs.Ω == rhs.Ω && lhs.ϕ == rhs.ϕ && typeof(lhs) == typeof(rhs)
end

function Base.:(==)(lhs::RydbergHamiltonian, rhs::RydbergHamiltonian)
    return lhs.rydberg_term == rhs.rydberg_term && lhs.rabi_term == rhs.rabi_term && lhs.detuning_term == rhs.detuning_term
end

function Base.:(==)(lhs::RydbergHamiltonian3, rhs::RydbergHamiltonian3)
    return lhs.rydberg_term == rhs.rydberg_term && 
        lhs.rabi_term_hf == rhs.rabi_term_hf && lhs.detuning_term_hf == rhs.detuning_term_hf &&
        lhs.rabi_term_r == rhs.rabi_term_r && lhs.detuning_term_r == rhs.detuning_term_r
end

Base.isreal(::RydInteract) = true
Base.isreal(::SumOfZAndNTypes) = true
Base.isreal(::SumOfXTypes) = true
Base.isreal(::SumOfXPhaseTypes) = false
Base.isreal(h::Add) = all(isreal, subblocks(h))
Base.isreal(h::Scale) = isreal(factor(h)) && isreal(content(h))
Base.isreal(h::RydbergHamiltonian) = !(h.rabi_term isa SumOfXPhase)
Base.isreal(h::RydbergHamiltonian3) = !(h.rabi_term_hf isa SumOfXPhase_01) && !(h.rabi_term_r isa SumOfXPhase_1r)






is_time_dependent(::Nothing) = false
function is_time_dependent(t::Union{RabiTypes, HyperfineRabiTypes, RydbergRabiTypes})
    (t isa Union{SumOfX, SumOfX_01, SumOfX_1r}) && return !is_const_param(t.Ω)
    (t isa Union{SumOfXPhase, SumOfXPhase_01, SumOfXPhase_1r}) && (return !is_const_param(t.Ω) || !is_const_param(t.ϕ))
    return false
end
function is_time_dependent(t::Union{DetuningTypes, HyperfineDetuningTypes, RydbergDetuningTypes})
    (t isa Union{SumOfN, SumOfN_1, SumOfN_r}) && return !is_const_param(t.Δ)
    return false
end
is_time_dependent(h::RydbergHamiltonian) = is_time_dependent(h.rabi_term) || is_time_dependent(h.detuning_term)
is_time_dependent(h::RydbergHamiltonian3) = 
    is_time_dependent(h.rabi_term_hf) || is_time_dependent(h.detuning_term_hf) ||
    is_time_dependent(h.rabi_term_r) || is_time_dependent(h.detuning_term_r)

using Test
using BloqadeExpr
using BloqadeExpr: default_unit
using Unitful: kHz, µHz, Hz, MHz, µm, m, mm, cm

@testset "term units" begin
    @test SumOfXPhase(5, 2kHz, 1.0).Ω ≈ 0.002
    @test SumOfX(5, 2kHz).Ω ≈ 0.002
    @test SumOfZ(5, 2kHz).Δ ≈ 0.002
    @test SumOfN(5, 2kHz).Δ ≈ 0.002
    @test SumOfXPhase(5, 2kHz, 2.0).ϕ ≈ 2.0
    
    # if its 32bit, use different test set for avoid overflow
    if sizeof(Int) == 8
        @test SumOfX(3, [2μHz,2Hz,2MHz]).Ω ≈ [2*1e-12,2*1e-6,2]
    else
        @test SumOfX(3, [0.5μHz,0.5Hz,0.5MHz]).Ω ≈ [5*1e-13,5*1e-7,0.5]
    end
    h = RydInteract(atoms = [(1,), (2,), (3,), (4)], C = 109.2kHz * µm^6)
    @test h.C ≈ 0.1092
    h = rydberg_h([(1,), (2,)], C = 109.2kHz * µm^6)
    @test h.rydberg_term.C ≈ 0.1092
end

unitless_values = [5, 0:0.1:1, [1,2,3]]
unit_values = [5m, 0cm:0.1cm:1cm, [1mm,2mm,3mm]]
conversion_exponent = [6, 4, 3]

@testset "convert $(typeof(unitful))" for (unitless, unitful, exponent) in zip(unitless_values, unit_values, conversion_exponent)
    @test default_unit(μm, unitful) == unitless*10^exponent
end

assert_has_time_method(fs::Number, name) = nothing # skip scalars

function assert_has_time_method(fs::Vector, name)
    for f in fs
        assert_has_time_method(f, name)
    end
end

function assert_has_time_method(f, name)
    return is_time_function(f) || throw(ArgumentError("invalid input for $name: method $f(::Real) is not defined"))
end

function assert_nsites(nsites::Int, p, name)
    p isa AbstractVector || p isa Tuple || return
    nsites == length(p) ||
        throw(ArgumentError("nsites does not match size of $name " * "expect $nsites, got $(length(p))"))
    return
end

function assert_param(nsites::Int, p, name)
    assert_nsites(nsites, p, name)
    return assert_has_time_method(p, name)
end

# NOTE: is_time_function is only used in constructor
# don't use it in other places since it's slow

"""
    is_time_function(f)

Check if a function has method whose
signature is of `Tuple{Real}`
or `Tuple{T} where {T <: Real}`.
"""
function is_time_function(f)
    hasmethod(f, Tuple{Real}) && return true
    for T in concrete_subtypes(Real)
        hasmethod(f, Tuple{T}) && return true
    end
    return false
end

function is_const_param(x)
    return x isa Number || x isa Vector{<:Number}
end

concrete_subtypes(::Type{T}) where {T} = concrete_subtypes!([], T)

function concrete_subtypes!(list::Vector{Any}, ::Type{T}) where {T}
    isconcretetype(T) && return push!(list, T)
    for S in subtypes(T)
        isconcretetype(S) && push!(list, S)
        concrete_subtypes!(list, S)
    end
    return list
end

is_time_function(fs::Vector) = all(is_time_function, fs)

"""
    AbstractSpace

Abstract type for spaces.
"""
abstract type AbstractSpace end

"""
    FullSpace <: AbstractSpace

A trait for the full space.
"""
struct FullSpace <: AbstractSpace end

"""
    fullspace

A constant for the [`FullSpace`](@ref).
"""
const fullspace = FullSpace()

"""
    Subspace{S <: AbstractVector} <: AbstractSpace

A `Dict`-like object stores the mapping between subspace and full space.
"""
struct Subspace{T, S<:AbstractVector{T}} <: AbstractSpace
    nqubits::Int
    map::Dict{T,T} # fullspace_index => subspace_index
    subspace_v::S

    function Subspace(nqubits::Int, map::Dict{T,T}, subspace_v) where T<:Integer
        # NOTE: the indices in `subspace_v` is in range 0:1<<nqubits-1
        maximum(subspace_v) ≤ (one(T) << nqubits-1) || throw(ArgumentError("subspace index is too large"))
        return new{T,typeof(subspace_v)}(nqubits, map, subspace_v)
    end
end

"""
    Subspace(nqubits::Int, subspace_v::AbstractVector)

Create a Subspace from given list of subspace indices in the corresponding full space.
"""
function Subspace(nqubits::Int, subspace_v::AbstractVector{T}) where T<:Integer
    subspace_v = sort(subspace_v)
    map = Dict{T,T}()
    for (subspace_index, fullspace_index) in enumerate(subspace_v)
        map[fullspace_index] = subspace_index
    end
    return Subspace(nqubits, map, subspace_v)
end

function Base.show(io::IO, ::MIME"text/plain", s::Subspace)
    print(io, s.nqubits, "-qubits ", length(s.subspace_v), "-elements ")
    summary(io, s)
    println(io, ":")

    mid_indent = 2
    tab(n) = " "^n

    N = length(s.subspace_v)
    lcol_width = ndigits(N) + mid_indent
    rcol_title = "fullspace"

    function print_line(sub_idx, ful_idx)
        print(io, tab(ndigits(N) - ndigits(sub_idx) + 1))
        printstyled(io, sub_idx; color = :light_black)
        # NOTE: right col also need a tab
        print(io, '│', tab(1))
        return printstyled(io, ful_idx)
    end

    println(io, '─'^(ndigits(N) + 1), "┬", '─'^(ndigits(maximum(s.subspace_v)) + 1))

    if get(io, :limit, false) && N > 10 # compact print
        print_line(1, s.subspace_v[1])
        println(io)
        print_line(2, s.subspace_v[2])
        println(io)
        print_line(3, s.subspace_v[3])
        println(io)
        print(io, tab(ndigits(N) ÷ 2 + 1))
        printstyled(io, tab(1), '⋮'; color = :light_black)
        println(io, '│', tab(1), '⋮')
        print_line(N - 2, s.subspace_v[end-2])
        println(io)
        print_line(N - 1, s.subspace_v[end-1])
        println(io)
        print_line(N, s.subspace_v[end])
    else
        for (sub_idx, ful_idx) in enumerate(s.subspace_v)
            print_line(sub_idx, ful_idx)
            if sub_idx != N
                println(io)
            end
        end
    end
end

Base.getindex(s::Subspace, key::Integer) = s.map[key]
Base.getindex(s::Subspace, key::BitStr) = s.map[buffer(key)]
Base.keys(s::Subspace) = keys(s.map)
Base.values(s::Subspace) = values(s.map)
Base.length(s::Subspace) = length(s.subspace_v)
Base.iterate(s::Subspace) = iterate(s.map)
Base.iterate(s::Subspace, st) = iterate(s.map, st)
Base.haskey(s::Subspace, key) = haskey(s.map, key)
Base.copy(s::Subspace) = Subspace(s.nqubits, copy(s.map), copy(s.subspace_v))
Base.vec(s::Subspace) = s.subspace_v
Base.to_index(ss::Subspace) = ss.subspace_v .+ 1

function Base.:(==)(x::Subspace, y::Subspace)
    return (x.nqubits == y.nqubits) && (x.map == y.map) && (x.subspace_v == y.subspace_v)
end

using Test
using BloqadeExpr
using YaoAPI
using LinearAlgebra
using Random
using SparseArrays
using SparseMatricesCSR
using LuxurySparse
using BloqadeExpr: Hamiltonian

atoms = [(1, 1), (1, 2), (1, 3), (1, 4), (1, 5)]
h = rydberg_h(atoms; Ω = 1.0, Δ = sin)

hlist = Hamiltonian(Float64, h)
@test length(hlist.fs) == 2
@test hlist.fs[end] === one

H = sum(zip(hlist.fs, hlist.ts)) do (f, t)
    return f(0.1) * t
end


@test tr(hlist(0.1)) ≈ tr(H)

# ThreadedMatrix unit tests
  # ThreadedMatrix with SparseMatrixCSC
  # Threaded Matrix with CSR and Diagonal matrix inside

@testset "ThreadedMatrix for Parallel Emulation (tr)" begin

    # these values are not mutated and can be re-used throughout the unit tests

    @testset "Transposed SparseMatrixCSC Matrix (tr)" begin

        #C_original = rand(ComplexF64, 10)
        #C_copy = deepcopy(C_original)

        A = sprand(ComplexF64, 20, 20, 0.3)
        A_dense = Matrix(A)
        A_threaded = BloqadeExpr.ThreadedMatrix(transpose(A))
        
        @test tr(A_dense) ≈ tr(A_threaded)
        
    end

    @testset "CSR-format Matrix (tr)" begin

        
        A = sprand(ComplexF64, 20, 20, 0.3)
        A_dense = Matrix(A)
        A_threaded = A |> transpose |> SparseMatrixCSR |>  BloqadeExpr.ThreadedMatrix

        @test tr(transpose(A_dense)) ≈ tr(A_threaded)

    end

    @testset "Diagonal Matrix (tr)" begin


        A = Diagonal(rand(ComplexF64, 20))
        A_dense = Matrix(A)
        A_threaded = A |> BloqadeExpr.ThreadedMatrix

        @test tr(A_dense) ≈ tr(A_threaded)

    end

    @testset "Permutation Matrix (tr)" begin


        A = PermMatrix(shuffle(1:20), rand(ComplexF64, 20))
        A_dense = Matrix(A)
        A_threaded = A |> BloqadeExpr.ThreadedMatrix
       
        @test tr(A_dense) ≈ tr(A_threaded)
        
    end

end

using Test
using InteractiveUtils
using BloqadeExpr: is_time_function, assert_nsites

@testset "is_time_function" begin
    @test is_time_function(sin) == true
    @test is_time_function(push!) == false
    tf_1(::Float64) = 0.0
    @test is_time_function(tf_1) == true
    tf_2(::Complex) = 0.0
    @test is_time_function(tf_2) == false
end

@testset "assert_nsites" begin
    @test assert_nsites(5, [1, 2, 3, 4, 5], :test) === nothing
    @test assert_nsites(5, 2.0, :test) === nothing
    @test_throws ArgumentError assert_nsites(4, [1, 2, 3, 4, 5], :test)
end

# a linear map for low-level hamiltonian representation
const backend = @load_preference("backend", "BloqadeExpr")

struct ThreadedMatrix{M <: AbstractMatrix}
    matrix::M

    # use Inner Constructor to avoid infinite loop of calling constructor on itself
    ThreadedMatrix(m::T) where {T<:AbstractMatrix} = new{typeof(m)}(m)
    function ThreadedMatrix(m::SparseMatrixCSC)
        @static if backend == "ThreadedSparseCSR" # should be conjugate transpose, then turned into SparseMatrixCSR
            transformed_matrix = m |> conj! |> transpose |> SparseMatrixCSR 
        elseif backend == "BloqadeExpr"
            transformed_matrix = m
        else
            throw(ArgumentError("The backend selected is not supported."))
        end

        return new{typeof(transformed_matrix)}(transformed_matrix)
    end

end

Base.size(m::ThreadedMatrix) = size(m.matrix)
Base.size(m::ThreadedMatrix, i) = size(m.matrix)[i]
Base.eltype(m::ThreadedMatrix) = eltype(m.matrix)
Base.pointer(m::T) where {T <: Diagonal} = pointer(m.diag)


precision_type(m::T) where {T <: Number} = real(typeof(m))
precision_type(m::T) where {T <: Diagonal} = real(eltype(m))
precision_type(m::T) where {T <: PermMatrix} = real(eltype(m))
precision_type(m::T) where {T <: SparseMatrixCSR} = real(eltype(m))
precision_type(m::T) where {T <: SparseMatrixCSC} = real(eltype(m))
precision_type(m::T) where {T <: ThreadedMatrix} = real(eltype(m.matrix))


"""
    struct Hamiltonian

`Hamiltonian` stores the dynamic prefactors of each term.
The actual hamiltonian is the sum of `f_i(t) * t_i` where
`f_i` and `t_i` are entries of `fs` and `ts`.
"""
struct Hamiltonian{FS<:Tuple,TS<:Tuple}
    fs::FS # prefactor of each term
    ts::TS # const linear map of each term

    function Hamiltonian(fs, ts)
        all(x -> size(x) == size(ts[1]), ts) || throw(ArgumentError("matrix term should have the same size"))
        return new{typeof(fs),typeof(ts)}(fs, ts)
    end
end

Base.size(h::Hamiltonian) = size(h.ts[1])
Base.size(h::Hamiltonian, idx::Int) = size(h.ts[1], idx)
function precision_type(h::Hamiltonian) 
    tp = unique(precision_type.(h.ts))
    return Union{tp...}
end
function highest_type(h::Hamiltonian)
    tp = unique(eltype.(h.ts))
    return promote_type(tp...)
end


Base.eltype(h::Hamiltonian) = highest_type(h)


Adapt.@adapt_structure Hamiltonian




abstract type RegularLinop end
abstract type SkewHermitian end

anti_type(::Type{LinearAlgebra.Hermitian}) = SkewHermitian
anti_type(::Type{SkewHermitian}) = LinearAlgebra.Hermitian
anti_type(::Type{RegularLinop}) = RegularLinop


"""
    struct SumOfLinop
A low-level linear-map object that explicitly evaluate time dependent 
coefficients at given time `t` fvals = fs(t) of Hamiltonian. 

This object supports the linear map interface `mul!(Y, H, X)`.
"""

struct SumOfLinop{OPTYPE, VS,TS}
    fvals::VS
    ts::TS
    function SumOfLinop{OPTYPE}(fvals::VS, ts::TS) where {OPTYPE, VS, TS}
        return new{OPTYPE,VS,TS}(fvals, ts)
    end
end

Base.size(h::SumOfLinop, idx::Int) = size(h.ts[1], idx)
Base.size(h::SumOfLinop) = size(h.ts[1])
function precision_type(h::SumOfLinop)
    tp = unique(precision_type.(h.ts))
    tp2 = unique(precision_type.(h.fvals))
    tp = unique((tp...,tp2...))
    return Union{tp...}
end
function highest_type(h::SumOfLinop)
    tp = unique(eltype.(h.ts))
    tp2 = unique(typeof.(h.fvals))
    return promote_type(tp...,tp2...)
end
Base.eltype(h::SumOfLinop) = highest_type(h)

function to_matrix(h::SumOfLinop)
    return sum(zip(h.fvals, h.ts)) do (f, t)
        return f * t
    end
end

function _getf(h::Hamiltonian,t) 
    return collect(map(h.fs) do f 
        return f(t)
    end
    )
end


## lowering by Hamiltonian, so its Hermitian type
(h::Hamiltonian)(t::Real) = SumOfLinop{LinearAlgebra.Hermitian}(_getf(h,t), h.ts)




storage_size(x) = sizeof(x)
storage_size(H::T) where {T <: ThreadedMatrix} = storage_size(H.matrix)
function storage_size(h::Hamiltonian)
    return sum(storage_size, h.ts)
end
function storage_size(H::SparseMatrixCSC)
    return sizeof(H.colptr) + sizeof(H.rowval) + sizeof(H.nzval)
end

function set_backend(backend::String)
    if !(backend in ("ThreadedSparseCSR", "BloqadeExpr" ))
        throw(ArgumentError("Invalid Backend provided, please select from, \"ThreadedSparseCSR\", \"BloqadeExpr\""))
    end

    @set_preferences!("backend" => backend)
    @info("New backend set; restart Julia session for this change to take effect!")
end
